package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class APIServiceListBuilder extends io.fabric8.kubernetes.api.model.APIServiceListFluentImpl<io.fabric8.kubernetes.api.model.APIServiceListBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.APIServiceList,io.fabric8.kubernetes.api.model.APIServiceListBuilder>{
  public APIServiceListBuilder() {
    this(false);
  }
  public APIServiceListBuilder(java.lang.Boolean validationEnabled) {
    this(new APIServiceList(), validationEnabled);
  }
  public APIServiceListBuilder(io.fabric8.kubernetes.api.model.APIServiceListFluent<?> fluent) {
    this(fluent, false);
  }
  public APIServiceListBuilder(io.fabric8.kubernetes.api.model.APIServiceListFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new APIServiceList(), validationEnabled);
  }
  public APIServiceListBuilder(io.fabric8.kubernetes.api.model.APIServiceListFluent<?> fluent,io.fabric8.kubernetes.api.model.APIServiceList instance) {
    this(fluent, instance, false);
  }
  public APIServiceListBuilder(io.fabric8.kubernetes.api.model.APIServiceListFluent<?> fluent,io.fabric8.kubernetes.api.model.APIServiceList instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withItems(instance.getItems()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  public APIServiceListBuilder(io.fabric8.kubernetes.api.model.APIServiceList instance) {
    this(instance,false);
  }
  public APIServiceListBuilder(io.fabric8.kubernetes.api.model.APIServiceList instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withItems(instance.getItems()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.APIServiceListFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.APIServiceList build() {
    APIServiceList buildable = new APIServiceList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    APIServiceListBuilder that = (APIServiceListBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}