package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.util.Iterator;
import java.util.List;
import java.lang.Boolean;
import java.lang.Integer;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public class AuthInfoFluentImpl<A extends io.fabric8.kubernetes.api.model.AuthInfoFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.kubernetes.api.model.AuthInfoFluent<A>{
  public AuthInfoFluentImpl() {
  }
  public AuthInfoFluentImpl(io.fabric8.kubernetes.api.model.AuthInfo instance) {
    this.withAs(instance.getAs()); 
    this.withAsGroups(instance.getAsGroups()); 
    this.withAsUserExtra(instance.getAsUserExtra()); 
    this.withAuthProvider(instance.getAuthProvider()); 
    this.withClientCertificate(instance.getClientCertificate()); 
    this.withClientCertificateData(instance.getClientCertificateData()); 
    this.withClientKey(instance.getClientKey()); 
    this.withClientKeyData(instance.getClientKeyData()); 
    this.withExec(instance.getExec()); 
    this.withExtensions(instance.getExtensions()); 
    this.withPassword(instance.getPassword()); 
    this.withToken(instance.getToken()); 
    this.withTokenFile(instance.getTokenFile()); 
    this.withUsername(instance.getUsername()); 
  }
  private java.lang.String as;
  private java.util.List<java.lang.String> asGroups = new java.util.ArrayList<java.lang.String>();
  private java.util.Map<java.lang.String,java.util.ArrayList<java.lang.String>> asUserExtra;
  private io.fabric8.kubernetes.api.model.AuthProviderConfigBuilder authProvider;
  private java.lang.String clientCertificate;
  private java.lang.String clientCertificateData;
  private java.lang.String clientKey;
  private java.lang.String clientKeyData;
  private io.fabric8.kubernetes.api.model.ExecConfigBuilder exec;
  private java.util.List<io.fabric8.kubernetes.api.model.NamedExtensionBuilder> extensions =  new java.util.ArrayList<io.fabric8.kubernetes.api.model.NamedExtensionBuilder>();
  private java.lang.String password;
  private java.lang.String token;
  private java.lang.String tokenFile;
  private java.lang.String username;
  public java.lang.String getAs() {
    return this.as;
  }
  public A withAs(java.lang.String as) {
    this.as=as; return (A) this;
  }
  public java.lang.Boolean hasAs() {
    return this.as != null;
  }
  
  /**
   * Method is deprecated. use withAs instead.
   */
  @java.lang.Deprecated
  public A withNewAs(java.lang.String arg0) {
    return (A)withAs(new String(arg0));
  }
  public A addToAsGroups(java.lang.Integer index,java.lang.String item) {
    if (this.asGroups == null) {this.asGroups = new java.util.ArrayList<java.lang.String>();}
    this.asGroups.add(index, item);
    return (A)this;
  }
  public A setToAsGroups(java.lang.Integer index,java.lang.String item) {
    if (this.asGroups == null) {this.asGroups = new java.util.ArrayList<java.lang.String>();}
    this.asGroups.set(index, item); return (A)this;
  }
  public A addToAsGroups(java.lang.String... items) {
    if (this.asGroups == null) {this.asGroups = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.asGroups.add(item);} return (A)this;
  }
  public A addAllToAsGroups(java.util.Collection<java.lang.String> items) {
    if (this.asGroups == null) {this.asGroups = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.asGroups.add(item);} return (A)this;
  }
  public A removeFromAsGroups(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.asGroups!= null){ this.asGroups.remove(item);}} return (A)this;
  }
  public A removeAllFromAsGroups(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.asGroups!= null){ this.asGroups.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getAsGroups() {
    return this.asGroups;
  }
  public java.lang.String getAsGroup(java.lang.Integer index) {
    return this.asGroups.get(index);
  }
  public java.lang.String getFirstAsGroup() {
    return this.asGroups.get(0);
  }
  public java.lang.String getLastAsGroup() {
    return this.asGroups.get(asGroups.size() - 1);
  }
  public java.lang.String getMatchingAsGroup(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: asGroups) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingAsGroup(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: asGroups) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withAsGroups(java.util.List<java.lang.String> asGroups) {
    if (asGroups != null) {this.asGroups = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : asGroups){this.addToAsGroups(item);}} else { this.asGroups = null;} return (A) this;
  }
  public A withAsGroups(java.lang.String... asGroups) {
    if (this.asGroups != null) {this.asGroups.clear();}
    if (asGroups != null) {for (java.lang.String item :asGroups){ this.addToAsGroups(item);}} return (A) this;
  }
  public java.lang.Boolean hasAsGroups() {
    return asGroups != null && !asGroups.isEmpty();
  }
  public A addNewAsGroup(java.lang.String arg0) {
    return (A)addToAsGroups(new String(arg0));
  }
  public A addToAsUserExtra(java.lang.String key,java.util.ArrayList<java.lang.String> value) {
    if(this.asUserExtra == null && key != null && value != null) { this.asUserExtra = new java.util.LinkedHashMap<java.lang.String,java.util.ArrayList<java.lang.String>>(); }
    if(key != null && value != null) {this.asUserExtra.put(key, value);} return (A)this;
  }
  public A addToAsUserExtra(java.util.Map<java.lang.String,java.util.ArrayList<java.lang.String>> map) {
    if(this.asUserExtra == null && map != null) { this.asUserExtra = new java.util.LinkedHashMap<java.lang.String,java.util.ArrayList<java.lang.String>>(); }
    if(map != null) { this.asUserExtra.putAll(map);} return (A)this;
  }
  public A removeFromAsUserExtra(java.lang.String key) {
    if(this.asUserExtra == null) { return (A) this; }
    if(key != null && this.asUserExtra != null) {this.asUserExtra.remove(key);} return (A)this;
  }
  public A removeFromAsUserExtra(java.util.Map<java.lang.String,java.util.ArrayList<java.lang.String>> map) {
    if(this.asUserExtra == null) { return (A) this; }
    if(map != null) { for(Object key : map.keySet()) {if (this.asUserExtra != null){this.asUserExtra.remove(key);}}} return (A)this;
  }
  public java.util.Map<java.lang.String,java.util.ArrayList<java.lang.String>> getAsUserExtra() {
    return this.asUserExtra;
  }
  public <K,V>A withAsUserExtra(java.util.Map<java.lang.String,java.util.ArrayList<java.lang.String>> asUserExtra) {
    if (asUserExtra == null) { this.asUserExtra =  null;} else {this.asUserExtra = new java.util.LinkedHashMap<java.lang.String,java.util.ArrayList<java.lang.String>>(asUserExtra);} return (A) this;
  }
  public java.lang.Boolean hasAsUserExtra() {
    return this.asUserExtra != null;
  }
  
  /**
   * This method has been deprecated, please use method buildAuthProvider instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.AuthProviderConfig getAuthProvider() {
    return this.authProvider!=null?this.authProvider.build():null;
  }
  public io.fabric8.kubernetes.api.model.AuthProviderConfig buildAuthProvider() {
    return this.authProvider!=null?this.authProvider.build():null;
  }
  public A withAuthProvider(io.fabric8.kubernetes.api.model.AuthProviderConfig authProvider) {
    _visitables.get("authProvider").remove(this.authProvider);
    if (authProvider!=null){ this.authProvider= new io.fabric8.kubernetes.api.model.AuthProviderConfigBuilder(authProvider); _visitables.get("authProvider").add(this.authProvider);} return (A) this;
  }
  public java.lang.Boolean hasAuthProvider() {
    return this.authProvider != null;
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<A> withNewAuthProvider() {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.AuthProviderNestedImpl();
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<A> withNewAuthProviderLike(io.fabric8.kubernetes.api.model.AuthProviderConfig item) {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.AuthProviderNestedImpl(item);
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<A> editAuthProvider() {
    return withNewAuthProviderLike(getAuthProvider());
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<A> editOrNewAuthProvider() {
    return withNewAuthProviderLike(getAuthProvider() != null ? getAuthProvider(): new io.fabric8.kubernetes.api.model.AuthProviderConfigBuilder().build());
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<A> editOrNewAuthProviderLike(io.fabric8.kubernetes.api.model.AuthProviderConfig item) {
    return withNewAuthProviderLike(getAuthProvider() != null ? getAuthProvider(): item);
  }
  public java.lang.String getClientCertificate() {
    return this.clientCertificate;
  }
  public A withClientCertificate(java.lang.String clientCertificate) {
    this.clientCertificate=clientCertificate; return (A) this;
  }
  public java.lang.Boolean hasClientCertificate() {
    return this.clientCertificate != null;
  }
  
  /**
   * Method is deprecated. use withClientCertificate instead.
   */
  @java.lang.Deprecated
  public A withNewClientCertificate(java.lang.String arg0) {
    return (A)withClientCertificate(new String(arg0));
  }
  public java.lang.String getClientCertificateData() {
    return this.clientCertificateData;
  }
  public A withClientCertificateData(java.lang.String clientCertificateData) {
    this.clientCertificateData=clientCertificateData; return (A) this;
  }
  public java.lang.Boolean hasClientCertificateData() {
    return this.clientCertificateData != null;
  }
  
  /**
   * Method is deprecated. use withClientCertificateData instead.
   */
  @java.lang.Deprecated
  public A withNewClientCertificateData(java.lang.String arg0) {
    return (A)withClientCertificateData(new String(arg0));
  }
  public java.lang.String getClientKey() {
    return this.clientKey;
  }
  public A withClientKey(java.lang.String clientKey) {
    this.clientKey=clientKey; return (A) this;
  }
  public java.lang.Boolean hasClientKey() {
    return this.clientKey != null;
  }
  
  /**
   * Method is deprecated. use withClientKey instead.
   */
  @java.lang.Deprecated
  public A withNewClientKey(java.lang.String arg0) {
    return (A)withClientKey(new String(arg0));
  }
  public java.lang.String getClientKeyData() {
    return this.clientKeyData;
  }
  public A withClientKeyData(java.lang.String clientKeyData) {
    this.clientKeyData=clientKeyData; return (A) this;
  }
  public java.lang.Boolean hasClientKeyData() {
    return this.clientKeyData != null;
  }
  
  /**
   * Method is deprecated. use withClientKeyData instead.
   */
  @java.lang.Deprecated
  public A withNewClientKeyData(java.lang.String arg0) {
    return (A)withClientKeyData(new String(arg0));
  }
  
  /**
   * This method has been deprecated, please use method buildExec instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ExecConfig getExec() {
    return this.exec!=null?this.exec.build():null;
  }
  public io.fabric8.kubernetes.api.model.ExecConfig buildExec() {
    return this.exec!=null?this.exec.build():null;
  }
  public A withExec(io.fabric8.kubernetes.api.model.ExecConfig exec) {
    _visitables.get("exec").remove(this.exec);
    if (exec!=null){ this.exec= new io.fabric8.kubernetes.api.model.ExecConfigBuilder(exec); _visitables.get("exec").add(this.exec);} return (A) this;
  }
  public java.lang.Boolean hasExec() {
    return this.exec != null;
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<A> withNewExec() {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.ExecNestedImpl();
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<A> withNewExecLike(io.fabric8.kubernetes.api.model.ExecConfig item) {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.ExecNestedImpl(item);
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<A> editExec() {
    return withNewExecLike(getExec());
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<A> editOrNewExec() {
    return withNewExecLike(getExec() != null ? getExec(): new io.fabric8.kubernetes.api.model.ExecConfigBuilder().build());
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<A> editOrNewExecLike(io.fabric8.kubernetes.api.model.ExecConfig item) {
    return withNewExecLike(getExec() != null ? getExec(): item);
  }
  public A addToExtensions(java.lang.Integer index,io.fabric8.kubernetes.api.model.NamedExtension item) {
    if (this.extensions == null) {this.extensions = new java.util.ArrayList<io.fabric8.kubernetes.api.model.NamedExtensionBuilder>();}
    io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(item);_visitables.get("extensions").add(index >= 0 ? index : _visitables.get("extensions").size(), builder);this.extensions.add(index >= 0 ? index : extensions.size(), builder); return (A)this;
  }
  public A setToExtensions(java.lang.Integer index,io.fabric8.kubernetes.api.model.NamedExtension item) {
    if (this.extensions == null) {this.extensions = new java.util.ArrayList<io.fabric8.kubernetes.api.model.NamedExtensionBuilder>();}
    io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(item);
    if (index < 0 || index >= _visitables.get("extensions").size()) { _visitables.get("extensions").add(builder); } else { _visitables.get("extensions").set(index, builder);}
    if (index < 0 || index >= extensions.size()) { extensions.add(builder); } else { extensions.set(index, builder);}
     return (A)this;
  }
  public A addToExtensions(io.fabric8.kubernetes.api.model.NamedExtension... items) {
    if (this.extensions == null) {this.extensions = new java.util.ArrayList<io.fabric8.kubernetes.api.model.NamedExtensionBuilder>();}
    for (io.fabric8.kubernetes.api.model.NamedExtension item : items) {io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(item);_visitables.get("extensions").add(builder);this.extensions.add(builder);} return (A)this;
  }
  public A addAllToExtensions(java.util.Collection<io.fabric8.kubernetes.api.model.NamedExtension> items) {
    if (this.extensions == null) {this.extensions = new java.util.ArrayList<io.fabric8.kubernetes.api.model.NamedExtensionBuilder>();}
    for (io.fabric8.kubernetes.api.model.NamedExtension item : items) {io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(item);_visitables.get("extensions").add(builder);this.extensions.add(builder);} return (A)this;
  }
  public A removeFromExtensions(io.fabric8.kubernetes.api.model.NamedExtension... items) {
    for (io.fabric8.kubernetes.api.model.NamedExtension item : items) {io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(item);_visitables.get("extensions").remove(builder);if (this.extensions != null) {this.extensions.remove(builder);}} return (A)this;
  }
  public A removeAllFromExtensions(java.util.Collection<io.fabric8.kubernetes.api.model.NamedExtension> items) {
    for (io.fabric8.kubernetes.api.model.NamedExtension item : items) {io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(item);_visitables.get("extensions").remove(builder);if (this.extensions != null) {this.extensions.remove(builder);}} return (A)this;
  }
  public A removeMatchingFromExtensions(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NamedExtensionBuilder> predicate) {
    if (extensions == null) return (A) this;
    final Iterator<io.fabric8.kubernetes.api.model.NamedExtensionBuilder> each = extensions.iterator();
    final List visitables = _visitables.get("extensions");
    while (each.hasNext()) {
      io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder = each.next();
      if (predicate.test(builder)) {
        visitables.remove(builder);
        each.remove();
      }
    }
    return (A)this;
  }
  
  /**
   * This method has been deprecated, please use method buildExtensions instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.NamedExtension> getExtensions() {
    return build(extensions);
  }
  public java.util.List<io.fabric8.kubernetes.api.model.NamedExtension> buildExtensions() {
    return build(extensions);
  }
  public io.fabric8.kubernetes.api.model.NamedExtension buildExtension(java.lang.Integer index) {
    return this.extensions.get(index).build();
  }
  public io.fabric8.kubernetes.api.model.NamedExtension buildFirstExtension() {
    return this.extensions.get(0).build();
  }
  public io.fabric8.kubernetes.api.model.NamedExtension buildLastExtension() {
    return this.extensions.get(extensions.size() - 1).build();
  }
  public io.fabric8.kubernetes.api.model.NamedExtension buildMatchingExtension(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NamedExtensionBuilder> predicate) {
    for (io.fabric8.kubernetes.api.model.NamedExtensionBuilder item: extensions) { if(predicate.test(item)){ return item.build();} } return null;
  }
  public java.lang.Boolean hasMatchingExtension(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NamedExtensionBuilder> predicate) {
    for (io.fabric8.kubernetes.api.model.NamedExtensionBuilder item: extensions) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withExtensions(java.util.List<io.fabric8.kubernetes.api.model.NamedExtension> extensions) {
    if (this.extensions != null) { _visitables.get("extensions").removeAll(this.extensions);}
    if (extensions != null) {this.extensions = new java.util.ArrayList<io.fabric8.kubernetes.api.model.NamedExtensionBuilder>(); for (io.fabric8.kubernetes.api.model.NamedExtension item : extensions){this.addToExtensions(item);}} else { this.extensions = null;} return (A) this;
  }
  public A withExtensions(io.fabric8.kubernetes.api.model.NamedExtension... extensions) {
    if (this.extensions != null) {this.extensions.clear();}
    if (extensions != null) {for (io.fabric8.kubernetes.api.model.NamedExtension item :extensions){ this.addToExtensions(item);}} return (A) this;
  }
  public java.lang.Boolean hasExtensions() {
    return extensions != null && !extensions.isEmpty();
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> addNewExtension() {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.ExtensionsNestedImpl();
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> addNewExtensionLike(io.fabric8.kubernetes.api.model.NamedExtension item) {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.ExtensionsNestedImpl(-1, item);
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> setNewExtensionLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.NamedExtension item) {
    return new io.fabric8.kubernetes.api.model.AuthInfoFluentImpl.ExtensionsNestedImpl(index, item);
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> editExtension(java.lang.Integer index) {
    if (extensions.size() <= index) throw new RuntimeException("Can't edit extensions. Index exceeds size.");
    return setNewExtensionLike(index, buildExtension(index));
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> editFirstExtension() {
    if (extensions.size() == 0) throw new RuntimeException("Can't edit first extensions. The list is empty.");
    return setNewExtensionLike(0, buildExtension(0));
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> editLastExtension() {
    int index = extensions.size() - 1;
    if (index < 0) throw new RuntimeException("Can't edit last extensions. The list is empty.");
    return setNewExtensionLike(index, buildExtension(index));
  }
  public io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<A> editMatchingExtension(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NamedExtensionBuilder> predicate) {
    int index = -1;
    for (int i=0;i<extensions.size();i++) { 
    if (predicate.test(extensions.get(i))) {index = i; break;}
    } 
    if (index < 0) throw new RuntimeException("Can't edit matching extensions. No match found.");
    return setNewExtensionLike(index, buildExtension(index));
  }
  public java.lang.String getPassword() {
    return this.password;
  }
  public A withPassword(java.lang.String password) {
    this.password=password; return (A) this;
  }
  public java.lang.Boolean hasPassword() {
    return this.password != null;
  }
  
  /**
   * Method is deprecated. use withPassword instead.
   */
  @java.lang.Deprecated
  public A withNewPassword(java.lang.String arg0) {
    return (A)withPassword(new String(arg0));
  }
  public java.lang.String getToken() {
    return this.token;
  }
  public A withToken(java.lang.String token) {
    this.token=token; return (A) this;
  }
  public java.lang.Boolean hasToken() {
    return this.token != null;
  }
  
  /**
   * Method is deprecated. use withToken instead.
   */
  @java.lang.Deprecated
  public A withNewToken(java.lang.String arg0) {
    return (A)withToken(new String(arg0));
  }
  public java.lang.String getTokenFile() {
    return this.tokenFile;
  }
  public A withTokenFile(java.lang.String tokenFile) {
    this.tokenFile=tokenFile; return (A) this;
  }
  public java.lang.Boolean hasTokenFile() {
    return this.tokenFile != null;
  }
  
  /**
   * Method is deprecated. use withTokenFile instead.
   */
  @java.lang.Deprecated
  public A withNewTokenFile(java.lang.String arg0) {
    return (A)withTokenFile(new String(arg0));
  }
  public java.lang.String getUsername() {
    return this.username;
  }
  public A withUsername(java.lang.String username) {
    this.username=username; return (A) this;
  }
  public java.lang.Boolean hasUsername() {
    return this.username != null;
  }
  
  /**
   * Method is deprecated. use withUsername instead.
   */
  @java.lang.Deprecated
  public A withNewUsername(java.lang.String arg0) {
    return (A)withUsername(new String(arg0));
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    AuthInfoFluentImpl that = (AuthInfoFluentImpl) o;
    if (as != null ? !as.equals(that.as) :that.as != null) return false;
    if (asGroups != null ? !asGroups.equals(that.asGroups) :that.asGroups != null) return false;
    if (asUserExtra != null ? !asUserExtra.equals(that.asUserExtra) :that.asUserExtra != null) return false;
    if (authProvider != null ? !authProvider.equals(that.authProvider) :that.authProvider != null) return false;
    if (clientCertificate != null ? !clientCertificate.equals(that.clientCertificate) :that.clientCertificate != null) return false;
    if (clientCertificateData != null ? !clientCertificateData.equals(that.clientCertificateData) :that.clientCertificateData != null) return false;
    if (clientKey != null ? !clientKey.equals(that.clientKey) :that.clientKey != null) return false;
    if (clientKeyData != null ? !clientKeyData.equals(that.clientKeyData) :that.clientKeyData != null) return false;
    if (exec != null ? !exec.equals(that.exec) :that.exec != null) return false;
    if (extensions != null ? !extensions.equals(that.extensions) :that.extensions != null) return false;
    if (password != null ? !password.equals(that.password) :that.password != null) return false;
    if (token != null ? !token.equals(that.token) :that.token != null) return false;
    if (tokenFile != null ? !tokenFile.equals(that.tokenFile) :that.tokenFile != null) return false;
    if (username != null ? !username.equals(that.username) :that.username != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(as,  asGroups,  asUserExtra,  authProvider,  clientCertificate,  clientCertificateData,  clientKey,  clientKeyData,  exec,  extensions,  password,  token,  tokenFile,  username,  super.hashCode());
  }
  public class AuthProviderNestedImpl<N> extends io.fabric8.kubernetes.api.model.AuthProviderConfigFluentImpl<io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<N>> implements io.fabric8.kubernetes.api.model.AuthInfoFluent.AuthProviderNested<N>,io.fabric8.kubernetes.api.builder.Nested<N>{
    AuthProviderNestedImpl(io.fabric8.kubernetes.api.model.AuthProviderConfig item) {
      this.builder = new io.fabric8.kubernetes.api.model.AuthProviderConfigBuilder(this, item);
    }
    AuthProviderNestedImpl() {
      this.builder = new io.fabric8.kubernetes.api.model.AuthProviderConfigBuilder(this);
    }
    io.fabric8.kubernetes.api.model.AuthProviderConfigBuilder builder;
    public N and() {
      return (N) AuthInfoFluentImpl.this.withAuthProvider(builder.build());
    }
    public N endAuthProvider() {
      return and();
    }
    
  }
  public class ExecNestedImpl<N> extends io.fabric8.kubernetes.api.model.ExecConfigFluentImpl<io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<N>> implements io.fabric8.kubernetes.api.model.AuthInfoFluent.ExecNested<N>,io.fabric8.kubernetes.api.builder.Nested<N>{
    ExecNestedImpl(io.fabric8.kubernetes.api.model.ExecConfig item) {
      this.builder = new io.fabric8.kubernetes.api.model.ExecConfigBuilder(this, item);
    }
    ExecNestedImpl() {
      this.builder = new io.fabric8.kubernetes.api.model.ExecConfigBuilder(this);
    }
    io.fabric8.kubernetes.api.model.ExecConfigBuilder builder;
    public N and() {
      return (N) AuthInfoFluentImpl.this.withExec(builder.build());
    }
    public N endExec() {
      return and();
    }
    
  }
  public class ExtensionsNestedImpl<N> extends io.fabric8.kubernetes.api.model.NamedExtensionFluentImpl<io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<N>> implements io.fabric8.kubernetes.api.model.AuthInfoFluent.ExtensionsNested<N>,io.fabric8.kubernetes.api.builder.Nested<N>{
    ExtensionsNestedImpl(java.lang.Integer index,io.fabric8.kubernetes.api.model.NamedExtension item) {
      this.index = index;
      this.builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(this, item);
    }
    ExtensionsNestedImpl() {
      this.index = -1;
      this.builder = new io.fabric8.kubernetes.api.model.NamedExtensionBuilder(this);
    }
    io.fabric8.kubernetes.api.model.NamedExtensionBuilder builder;
    java.lang.Integer index;
    public N and() {
      return (N) AuthInfoFluentImpl.this.setToExtensions(index,builder.build());
    }
    public N endExtension() {
      return and();
    }
    
  }
  
}