package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class BindingBuilder extends io.fabric8.kubernetes.api.model.BindingFluentImpl<io.fabric8.kubernetes.api.model.BindingBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.Binding,io.fabric8.kubernetes.api.model.BindingBuilder>{
  public BindingBuilder() {
    this(false);
  }
  public BindingBuilder(java.lang.Boolean validationEnabled) {
    this(new Binding(), validationEnabled);
  }
  public BindingBuilder(io.fabric8.kubernetes.api.model.BindingFluent<?> fluent) {
    this(fluent, false);
  }
  public BindingBuilder(io.fabric8.kubernetes.api.model.BindingFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new Binding(), validationEnabled);
  }
  public BindingBuilder(io.fabric8.kubernetes.api.model.BindingFluent<?> fluent,io.fabric8.kubernetes.api.model.Binding instance) {
    this(fluent, instance, false);
  }
  public BindingBuilder(io.fabric8.kubernetes.api.model.BindingFluent<?> fluent,io.fabric8.kubernetes.api.model.Binding instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    fluent.withTarget(instance.getTarget()); 
    this.validationEnabled = validationEnabled; 
  }
  public BindingBuilder(io.fabric8.kubernetes.api.model.Binding instance) {
    this(instance,false);
  }
  public BindingBuilder(io.fabric8.kubernetes.api.model.Binding instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.withTarget(instance.getTarget()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.BindingFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.Binding build() {
    Binding buildable = new Binding(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getTarget());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    BindingBuilder that = (BindingBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}