package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ComponentConditionBuilder extends io.fabric8.kubernetes.api.model.ComponentConditionFluentImpl<io.fabric8.kubernetes.api.model.ComponentConditionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.ComponentCondition,io.fabric8.kubernetes.api.model.ComponentConditionBuilder>{
  public ComponentConditionBuilder() {
    this(false);
  }
  public ComponentConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new ComponentCondition(), validationEnabled);
  }
  public ComponentConditionBuilder(io.fabric8.kubernetes.api.model.ComponentConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public ComponentConditionBuilder(io.fabric8.kubernetes.api.model.ComponentConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ComponentCondition(), validationEnabled);
  }
  public ComponentConditionBuilder(io.fabric8.kubernetes.api.model.ComponentConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.ComponentCondition instance) {
    this(fluent, instance, false);
  }
  public ComponentConditionBuilder(io.fabric8.kubernetes.api.model.ComponentConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.ComponentCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withError(instance.getError()); 
    fluent.withMessage(instance.getMessage()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public ComponentConditionBuilder(io.fabric8.kubernetes.api.model.ComponentCondition instance) {
    this(instance,false);
  }
  public ComponentConditionBuilder(io.fabric8.kubernetes.api.model.ComponentCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withError(instance.getError()); 
    this.withMessage(instance.getMessage()); 
    this.withStatus(instance.getStatus()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.ComponentConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.ComponentCondition build() {
    ComponentCondition buildable = new ComponentCondition(fluent.getError(),fluent.getMessage(),fluent.getStatus(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ComponentConditionBuilder that = (ComponentConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}