package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ComponentStatusBuilder extends io.fabric8.kubernetes.api.model.ComponentStatusFluentImpl<io.fabric8.kubernetes.api.model.ComponentStatusBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.ComponentStatus,io.fabric8.kubernetes.api.model.ComponentStatusBuilder>{
  public ComponentStatusBuilder() {
    this(false);
  }
  public ComponentStatusBuilder(java.lang.Boolean validationEnabled) {
    this(new ComponentStatus(), validationEnabled);
  }
  public ComponentStatusBuilder(io.fabric8.kubernetes.api.model.ComponentStatusFluent<?> fluent) {
    this(fluent, false);
  }
  public ComponentStatusBuilder(io.fabric8.kubernetes.api.model.ComponentStatusFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ComponentStatus(), validationEnabled);
  }
  public ComponentStatusBuilder(io.fabric8.kubernetes.api.model.ComponentStatusFluent<?> fluent,io.fabric8.kubernetes.api.model.ComponentStatus instance) {
    this(fluent, instance, false);
  }
  public ComponentStatusBuilder(io.fabric8.kubernetes.api.model.ComponentStatusFluent<?> fluent,io.fabric8.kubernetes.api.model.ComponentStatus instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withConditions(instance.getConditions()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  public ComponentStatusBuilder(io.fabric8.kubernetes.api.model.ComponentStatus instance) {
    this(instance,false);
  }
  public ComponentStatusBuilder(io.fabric8.kubernetes.api.model.ComponentStatus instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withConditions(instance.getConditions()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.ComponentStatusFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.ComponentStatus build() {
    ComponentStatus buildable = new ComponentStatus(fluent.getApiVersion(),fluent.getConditions(),fluent.getKind(),fluent.getMetadata());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ComponentStatusBuilder that = (ComponentStatusBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}