package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ConditionBuilder extends io.fabric8.kubernetes.api.model.ConditionFluentImpl<io.fabric8.kubernetes.api.model.ConditionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.Condition,io.fabric8.kubernetes.api.model.ConditionBuilder>{
  public ConditionBuilder() {
    this(false);
  }
  public ConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new Condition(), validationEnabled);
  }
  public ConditionBuilder(io.fabric8.kubernetes.api.model.ConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public ConditionBuilder(io.fabric8.kubernetes.api.model.ConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new Condition(), validationEnabled);
  }
  public ConditionBuilder(io.fabric8.kubernetes.api.model.ConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.Condition instance) {
    this(fluent, instance, false);
  }
  public ConditionBuilder(io.fabric8.kubernetes.api.model.ConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.Condition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLastTransitionTime(instance.getLastTransitionTime()); 
    fluent.withMessage(instance.getMessage()); 
    fluent.withObservedGeneration(instance.getObservedGeneration()); 
    fluent.withReason(instance.getReason()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public ConditionBuilder(io.fabric8.kubernetes.api.model.Condition instance) {
    this(instance,false);
  }
  public ConditionBuilder(io.fabric8.kubernetes.api.model.Condition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLastTransitionTime(instance.getLastTransitionTime()); 
    this.withMessage(instance.getMessage()); 
    this.withObservedGeneration(instance.getObservedGeneration()); 
    this.withReason(instance.getReason()); 
    this.withStatus(instance.getStatus()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.ConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.Condition build() {
    Condition buildable = new Condition(fluent.getLastTransitionTime(),fluent.getMessage(),fluent.getObservedGeneration(),fluent.getReason(),fluent.getStatus(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ConditionBuilder that = (ConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}