package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.Nested;
import java.lang.String;
import java.util.LinkedHashMap;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

 /**
  * Generated
  */
public class ConfigMapFluentImpl<A extends io.fabric8.kubernetes.api.model.ConfigMapFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.kubernetes.api.model.ConfigMapFluent<A>{
  public ConfigMapFluentImpl() {
  }
  public ConfigMapFluentImpl(io.fabric8.kubernetes.api.model.ConfigMap instance) {
    this.withApiVersion(instance.getApiVersion()); 
    this.withBinaryData(instance.getBinaryData()); 
    this.withData(instance.getData()); 
    this.withImmutable(instance.getImmutable()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
  }
  private java.lang.String apiVersion;
  private java.util.Map<java.lang.String,java.lang.String> binaryData;
  private java.util.Map<java.lang.String,java.lang.String> data;
  private java.lang.Boolean immutable;
  private java.lang.String kind;
  private io.fabric8.kubernetes.api.model.ObjectMetaBuilder metadata;
  public java.lang.String getApiVersion() {
    return this.apiVersion;
  }
  public A withApiVersion(java.lang.String apiVersion) {
    this.apiVersion=apiVersion; return (A) this;
  }
  public java.lang.Boolean hasApiVersion() {
    return this.apiVersion != null;
  }
  
  /**
   * Method is deprecated. use withApiVersion instead.
   */
  @java.lang.Deprecated
  public A withNewApiVersion(java.lang.String arg0) {
    return (A)withApiVersion(new String(arg0));
  }
  public A addToBinaryData(java.lang.String key,java.lang.String value) {
    if(this.binaryData == null && key != null && value != null) { this.binaryData = new java.util.LinkedHashMap<java.lang.String,java.lang.String>(); }
    if(key != null && value != null) {this.binaryData.put(key, value);} return (A)this;
  }
  public A addToBinaryData(java.util.Map<java.lang.String,java.lang.String> map) {
    if(this.binaryData == null && map != null) { this.binaryData = new java.util.LinkedHashMap<java.lang.String,java.lang.String>(); }
    if(map != null) { this.binaryData.putAll(map);} return (A)this;
  }
  public A removeFromBinaryData(java.lang.String key) {
    if(this.binaryData == null) { return (A) this; }
    if(key != null && this.binaryData != null) {this.binaryData.remove(key);} return (A)this;
  }
  public A removeFromBinaryData(java.util.Map<java.lang.String,java.lang.String> map) {
    if(this.binaryData == null) { return (A) this; }
    if(map != null) { for(Object key : map.keySet()) {if (this.binaryData != null){this.binaryData.remove(key);}}} return (A)this;
  }
  public java.util.Map<java.lang.String,java.lang.String> getBinaryData() {
    return this.binaryData;
  }
  public <K,V>A withBinaryData(java.util.Map<java.lang.String,java.lang.String> binaryData) {
    if (binaryData == null) { this.binaryData =  null;} else {this.binaryData = new java.util.LinkedHashMap<java.lang.String,java.lang.String>(binaryData);} return (A) this;
  }
  public java.lang.Boolean hasBinaryData() {
    return this.binaryData != null;
  }
  public A addToData(java.lang.String key,java.lang.String value) {
    if(this.data == null && key != null && value != null) { this.data = new java.util.LinkedHashMap<java.lang.String,java.lang.String>(); }
    if(key != null && value != null) {this.data.put(key, value);} return (A)this;
  }
  public A addToData(java.util.Map<java.lang.String,java.lang.String> map) {
    if(this.data == null && map != null) { this.data = new java.util.LinkedHashMap<java.lang.String,java.lang.String>(); }
    if(map != null) { this.data.putAll(map);} return (A)this;
  }
  public A removeFromData(java.lang.String key) {
    if(this.data == null) { return (A) this; }
    if(key != null && this.data != null) {this.data.remove(key);} return (A)this;
  }
  public A removeFromData(java.util.Map<java.lang.String,java.lang.String> map) {
    if(this.data == null) { return (A) this; }
    if(map != null) { for(Object key : map.keySet()) {if (this.data != null){this.data.remove(key);}}} return (A)this;
  }
  public java.util.Map<java.lang.String,java.lang.String> getData() {
    return this.data;
  }
  public <K,V>A withData(java.util.Map<java.lang.String,java.lang.String> data) {
    if (data == null) { this.data =  null;} else {this.data = new java.util.LinkedHashMap<java.lang.String,java.lang.String>(data);} return (A) this;
  }
  public java.lang.Boolean hasData() {
    return this.data != null;
  }
  public java.lang.Boolean getImmutable() {
    return this.immutable;
  }
  public A withImmutable(java.lang.Boolean immutable) {
    this.immutable=immutable; return (A) this;
  }
  public java.lang.Boolean hasImmutable() {
    return this.immutable != null;
  }
  public java.lang.String getKind() {
    return this.kind;
  }
  public A withKind(java.lang.String kind) {
    this.kind=kind; return (A) this;
  }
  public java.lang.Boolean hasKind() {
    return this.kind != null;
  }
  
  /**
   * Method is deprecated. use withKind instead.
   */
  @java.lang.Deprecated
  public A withNewKind(java.lang.String arg0) {
    return (A)withKind(new String(arg0));
  }
  
  /**
   * This method has been deprecated, please use method buildMetadata instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ObjectMeta getMetadata() {
    return this.metadata!=null?this.metadata.build():null;
  }
  public io.fabric8.kubernetes.api.model.ObjectMeta buildMetadata() {
    return this.metadata!=null?this.metadata.build():null;
  }
  public A withMetadata(io.fabric8.kubernetes.api.model.ObjectMeta metadata) {
    _visitables.get("metadata").remove(this.metadata);
    if (metadata!=null){ this.metadata= new io.fabric8.kubernetes.api.model.ObjectMetaBuilder(metadata); _visitables.get("metadata").add(this.metadata);} return (A) this;
  }
  public java.lang.Boolean hasMetadata() {
    return this.metadata != null;
  }
  public io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<A> withNewMetadata() {
    return new io.fabric8.kubernetes.api.model.ConfigMapFluentImpl.MetadataNestedImpl();
  }
  public io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<A> withNewMetadataLike(io.fabric8.kubernetes.api.model.ObjectMeta item) {
    return new io.fabric8.kubernetes.api.model.ConfigMapFluentImpl.MetadataNestedImpl(item);
  }
  public io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<A> editMetadata() {
    return withNewMetadataLike(getMetadata());
  }
  public io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<A> editOrNewMetadata() {
    return withNewMetadataLike(getMetadata() != null ? getMetadata(): new io.fabric8.kubernetes.api.model.ObjectMetaBuilder().build());
  }
  public io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<A> editOrNewMetadataLike(io.fabric8.kubernetes.api.model.ObjectMeta item) {
    return withNewMetadataLike(getMetadata() != null ? getMetadata(): item);
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    ConfigMapFluentImpl that = (ConfigMapFluentImpl) o;
    if (apiVersion != null ? !apiVersion.equals(that.apiVersion) :that.apiVersion != null) return false;
    if (binaryData != null ? !binaryData.equals(that.binaryData) :that.binaryData != null) return false;
    if (data != null ? !data.equals(that.data) :that.data != null) return false;
    if (immutable != null ? !immutable.equals(that.immutable) :that.immutable != null) return false;
    if (kind != null ? !kind.equals(that.kind) :that.kind != null) return false;
    if (metadata != null ? !metadata.equals(that.metadata) :that.metadata != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(apiVersion,  binaryData,  data,  immutable,  kind,  metadata,  super.hashCode());
  }
  public class MetadataNestedImpl<N> extends io.fabric8.kubernetes.api.model.ObjectMetaFluentImpl<io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<N>> implements io.fabric8.kubernetes.api.model.ConfigMapFluent.MetadataNested<N>,io.fabric8.kubernetes.api.builder.Nested<N>{
    MetadataNestedImpl(io.fabric8.kubernetes.api.model.ObjectMeta item) {
      this.builder = new io.fabric8.kubernetes.api.model.ObjectMetaBuilder(this, item);
    }
    MetadataNestedImpl() {
      this.builder = new io.fabric8.kubernetes.api.model.ObjectMetaBuilder(this);
    }
    io.fabric8.kubernetes.api.model.ObjectMetaBuilder builder;
    public N and() {
      return (N) ConfigMapFluentImpl.this.withMetadata(builder.build());
    }
    public N endMetadata() {
      return and();
    }
    
  }
  
}