package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class DaemonEndpointBuilder extends io.fabric8.kubernetes.api.model.DaemonEndpointFluentImpl<io.fabric8.kubernetes.api.model.DaemonEndpointBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.DaemonEndpoint,io.fabric8.kubernetes.api.model.DaemonEndpointBuilder>{
  public DaemonEndpointBuilder() {
    this(false);
  }
  public DaemonEndpointBuilder(java.lang.Boolean validationEnabled) {
    this(new DaemonEndpoint(), validationEnabled);
  }
  public DaemonEndpointBuilder(io.fabric8.kubernetes.api.model.DaemonEndpointFluent<?> fluent) {
    this(fluent, false);
  }
  public DaemonEndpointBuilder(io.fabric8.kubernetes.api.model.DaemonEndpointFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new DaemonEndpoint(), validationEnabled);
  }
  public DaemonEndpointBuilder(io.fabric8.kubernetes.api.model.DaemonEndpointFluent<?> fluent,io.fabric8.kubernetes.api.model.DaemonEndpoint instance) {
    this(fluent, instance, false);
  }
  public DaemonEndpointBuilder(io.fabric8.kubernetes.api.model.DaemonEndpointFluent<?> fluent,io.fabric8.kubernetes.api.model.DaemonEndpoint instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withPort(instance.getPort()); 
    this.validationEnabled = validationEnabled; 
  }
  public DaemonEndpointBuilder(io.fabric8.kubernetes.api.model.DaemonEndpoint instance) {
    this(instance,false);
  }
  public DaemonEndpointBuilder(io.fabric8.kubernetes.api.model.DaemonEndpoint instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withPort(instance.getPort()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.DaemonEndpointFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.DaemonEndpoint build() {
    DaemonEndpoint buildable = new DaemonEndpoint(fluent.getPort());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    DaemonEndpointBuilder that = (DaemonEndpointBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}