package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class EnvVarSourceBuilder extends io.fabric8.kubernetes.api.model.EnvVarSourceFluentImpl<io.fabric8.kubernetes.api.model.EnvVarSourceBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.EnvVarSource,io.fabric8.kubernetes.api.model.EnvVarSourceBuilder>{
  public EnvVarSourceBuilder() {
    this(false);
  }
  public EnvVarSourceBuilder(java.lang.Boolean validationEnabled) {
    this(new EnvVarSource(), validationEnabled);
  }
  public EnvVarSourceBuilder(io.fabric8.kubernetes.api.model.EnvVarSourceFluent<?> fluent) {
    this(fluent, false);
  }
  public EnvVarSourceBuilder(io.fabric8.kubernetes.api.model.EnvVarSourceFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new EnvVarSource(), validationEnabled);
  }
  public EnvVarSourceBuilder(io.fabric8.kubernetes.api.model.EnvVarSourceFluent<?> fluent,io.fabric8.kubernetes.api.model.EnvVarSource instance) {
    this(fluent, instance, false);
  }
  public EnvVarSourceBuilder(io.fabric8.kubernetes.api.model.EnvVarSourceFluent<?> fluent,io.fabric8.kubernetes.api.model.EnvVarSource instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withConfigMapKeyRef(instance.getConfigMapKeyRef()); 
    fluent.withFieldRef(instance.getFieldRef()); 
    fluent.withResourceFieldRef(instance.getResourceFieldRef()); 
    fluent.withSecretKeyRef(instance.getSecretKeyRef()); 
    this.validationEnabled = validationEnabled; 
  }
  public EnvVarSourceBuilder(io.fabric8.kubernetes.api.model.EnvVarSource instance) {
    this(instance,false);
  }
  public EnvVarSourceBuilder(io.fabric8.kubernetes.api.model.EnvVarSource instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withConfigMapKeyRef(instance.getConfigMapKeyRef()); 
    this.withFieldRef(instance.getFieldRef()); 
    this.withResourceFieldRef(instance.getResourceFieldRef()); 
    this.withSecretKeyRef(instance.getSecretKeyRef()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.EnvVarSourceFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.EnvVarSource build() {
    EnvVarSource buildable = new EnvVarSource(fluent.getConfigMapKeyRef(),fluent.getFieldRef(),fluent.getResourceFieldRef(),fluent.getSecretKeyRef());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    EnvVarSourceBuilder that = (EnvVarSourceBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}