package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class EventSourceBuilder extends io.fabric8.kubernetes.api.model.EventSourceFluentImpl<io.fabric8.kubernetes.api.model.EventSourceBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.EventSource,io.fabric8.kubernetes.api.model.EventSourceBuilder>{
  public EventSourceBuilder() {
    this(false);
  }
  public EventSourceBuilder(java.lang.Boolean validationEnabled) {
    this(new EventSource(), validationEnabled);
  }
  public EventSourceBuilder(io.fabric8.kubernetes.api.model.EventSourceFluent<?> fluent) {
    this(fluent, false);
  }
  public EventSourceBuilder(io.fabric8.kubernetes.api.model.EventSourceFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new EventSource(), validationEnabled);
  }
  public EventSourceBuilder(io.fabric8.kubernetes.api.model.EventSourceFluent<?> fluent,io.fabric8.kubernetes.api.model.EventSource instance) {
    this(fluent, instance, false);
  }
  public EventSourceBuilder(io.fabric8.kubernetes.api.model.EventSourceFluent<?> fluent,io.fabric8.kubernetes.api.model.EventSource instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withComponent(instance.getComponent()); 
    fluent.withHost(instance.getHost()); 
    this.validationEnabled = validationEnabled; 
  }
  public EventSourceBuilder(io.fabric8.kubernetes.api.model.EventSource instance) {
    this(instance,false);
  }
  public EventSourceBuilder(io.fabric8.kubernetes.api.model.EventSource instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withComponent(instance.getComponent()); 
    this.withHost(instance.getHost()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.EventSourceFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.EventSource build() {
    EventSource buildable = new EventSource(fluent.getComponent(),fluent.getHost());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    EventSourceBuilder that = (EventSourceBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}