package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class GroupVersionResourceBuilder extends io.fabric8.kubernetes.api.model.GroupVersionResourceFluentImpl<io.fabric8.kubernetes.api.model.GroupVersionResourceBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.GroupVersionResource,io.fabric8.kubernetes.api.model.GroupVersionResourceBuilder>{
  public GroupVersionResourceBuilder() {
    this(false);
  }
  public GroupVersionResourceBuilder(java.lang.Boolean validationEnabled) {
    this(new GroupVersionResource(), validationEnabled);
  }
  public GroupVersionResourceBuilder(io.fabric8.kubernetes.api.model.GroupVersionResourceFluent<?> fluent) {
    this(fluent, false);
  }
  public GroupVersionResourceBuilder(io.fabric8.kubernetes.api.model.GroupVersionResourceFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new GroupVersionResource(), validationEnabled);
  }
  public GroupVersionResourceBuilder(io.fabric8.kubernetes.api.model.GroupVersionResourceFluent<?> fluent,io.fabric8.kubernetes.api.model.GroupVersionResource instance) {
    this(fluent, instance, false);
  }
  public GroupVersionResourceBuilder(io.fabric8.kubernetes.api.model.GroupVersionResourceFluent<?> fluent,io.fabric8.kubernetes.api.model.GroupVersionResource instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withGroup(instance.getGroup()); 
    fluent.withResource(instance.getResource()); 
    fluent.withVersion(instance.getVersion()); 
    this.validationEnabled = validationEnabled; 
  }
  public GroupVersionResourceBuilder(io.fabric8.kubernetes.api.model.GroupVersionResource instance) {
    this(instance,false);
  }
  public GroupVersionResourceBuilder(io.fabric8.kubernetes.api.model.GroupVersionResource instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withGroup(instance.getGroup()); 
    this.withResource(instance.getResource()); 
    this.withVersion(instance.getVersion()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.GroupVersionResourceFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.GroupVersionResource build() {
    GroupVersionResource buildable = new GroupVersionResource(fluent.getGroup(),fluent.getResource(),fluent.getVersion());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    GroupVersionResourceBuilder that = (GroupVersionResourceBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}