package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.Integer;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface HTTPGetActionFluent<A extends io.fabric8.kubernetes.api.model.HTTPGetActionFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.String getHost();
  public A withHost(java.lang.String host);
  public java.lang.Boolean hasHost();
  
  /**
   * Method is deprecated. use withHost instead.
   */
  @java.lang.Deprecated
  public A withNewHost(java.lang.String arg0);
  public A addToHttpHeaders(java.lang.Integer index,io.fabric8.kubernetes.api.model.HTTPHeader item);
  public A setToHttpHeaders(java.lang.Integer index,io.fabric8.kubernetes.api.model.HTTPHeader item);
  public A addToHttpHeaders(io.fabric8.kubernetes.api.model.HTTPHeader... items);
  public A addAllToHttpHeaders(java.util.Collection<io.fabric8.kubernetes.api.model.HTTPHeader> items);
  public A removeFromHttpHeaders(io.fabric8.kubernetes.api.model.HTTPHeader... items);
  public A removeAllFromHttpHeaders(java.util.Collection<io.fabric8.kubernetes.api.model.HTTPHeader> items);
  public A removeMatchingFromHttpHeaders(java.util.function.Predicate<io.fabric8.kubernetes.api.model.HTTPHeaderBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildHttpHeaders instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.HTTPHeader> getHttpHeaders();
  public java.util.List<io.fabric8.kubernetes.api.model.HTTPHeader> buildHttpHeaders();
  public io.fabric8.kubernetes.api.model.HTTPHeader buildHttpHeader(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.HTTPHeader buildFirstHttpHeader();
  public io.fabric8.kubernetes.api.model.HTTPHeader buildLastHttpHeader();
  public io.fabric8.kubernetes.api.model.HTTPHeader buildMatchingHttpHeader(java.util.function.Predicate<io.fabric8.kubernetes.api.model.HTTPHeaderBuilder> predicate);
  public java.lang.Boolean hasMatchingHttpHeader(java.util.function.Predicate<io.fabric8.kubernetes.api.model.HTTPHeaderBuilder> predicate);
  public A withHttpHeaders(java.util.List<io.fabric8.kubernetes.api.model.HTTPHeader> httpHeaders);
  public A withHttpHeaders(io.fabric8.kubernetes.api.model.HTTPHeader... httpHeaders);
  public java.lang.Boolean hasHttpHeaders();
  public A addNewHttpHeader(java.lang.String name,java.lang.String value);
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> addNewHttpHeader();
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> addNewHttpHeaderLike(io.fabric8.kubernetes.api.model.HTTPHeader item);
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> setNewHttpHeaderLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.HTTPHeader item);
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> editHttpHeader(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> editFirstHttpHeader();
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> editLastHttpHeader();
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<A> editMatchingHttpHeader(java.util.function.Predicate<io.fabric8.kubernetes.api.model.HTTPHeaderBuilder> predicate);
  public java.lang.String getPath();
  public A withPath(java.lang.String path);
  public java.lang.Boolean hasPath();
  
  /**
   * Method is deprecated. use withPath instead.
   */
  @java.lang.Deprecated
  public A withNewPath(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildPort instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.IntOrString getPort();
  public io.fabric8.kubernetes.api.model.IntOrString buildPort();
  public A withPort(io.fabric8.kubernetes.api.model.IntOrString port);
  public java.lang.Boolean hasPort();
  public A withNewPort(java.lang.Integer intVal);
  public A withNewPort(java.lang.String strVal);
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.PortNested<A> withNewPort();
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.PortNested<A> withNewPortLike(io.fabric8.kubernetes.api.model.IntOrString item);
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.PortNested<A> editPort();
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.PortNested<A> editOrNewPort();
  public io.fabric8.kubernetes.api.model.HTTPGetActionFluent.PortNested<A> editOrNewPortLike(io.fabric8.kubernetes.api.model.IntOrString item);
  public java.lang.String getScheme();
  public A withScheme(java.lang.String scheme);
  public java.lang.Boolean hasScheme();
  
  /**
   * Method is deprecated. use withScheme instead.
   */
  @java.lang.Deprecated
  public A withNewScheme(java.lang.String arg0);
  public interface HttpHeadersNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.HTTPHeaderFluent<io.fabric8.kubernetes.api.model.HTTPGetActionFluent.HttpHeadersNested<N>>{
    public N and();
    public N endHttpHeader();
    
  }
  public interface PortNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.IntOrStringFluent<io.fabric8.kubernetes.api.model.HTTPGetActionFluent.PortNested<N>>{
    public N and();
    public N endPort();
    
  }
  
}