package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class KubeSchemaBuilder extends io.fabric8.kubernetes.api.model.KubeSchemaFluentImpl<io.fabric8.kubernetes.api.model.KubeSchemaBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.KubeSchema,io.fabric8.kubernetes.api.model.KubeSchemaBuilder>{
  public KubeSchemaBuilder() {
    this(false);
  }
  public KubeSchemaBuilder(java.lang.Boolean validationEnabled) {
    this(new KubeSchema(), validationEnabled);
  }
  public KubeSchemaBuilder(io.fabric8.kubernetes.api.model.KubeSchemaFluent<?> fluent) {
    this(fluent, false);
  }
  public KubeSchemaBuilder(io.fabric8.kubernetes.api.model.KubeSchemaFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new KubeSchema(), validationEnabled);
  }
  public KubeSchemaBuilder(io.fabric8.kubernetes.api.model.KubeSchemaFluent<?> fluent,io.fabric8.kubernetes.api.model.KubeSchema instance) {
    this(fluent, instance, false);
  }
  public KubeSchemaBuilder(io.fabric8.kubernetes.api.model.KubeSchemaFluent<?> fluent,io.fabric8.kubernetes.api.model.KubeSchema instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withAPIGroup(instance.getAPIGroup()); 
    fluent.withAPIGroupList(instance.getAPIGroupList()); 
    fluent.withAPIService(instance.getAPIService()); 
    fluent.withAPIServiceList(instance.getAPIServiceList()); 
    fluent.withBaseKubernetesList(instance.getBaseKubernetesList()); 
    fluent.withBinding(instance.getBinding()); 
    fluent.withComponentStatus(instance.getComponentStatus()); 
    fluent.withComponentStatusList(instance.getComponentStatusList()); 
    fluent.withCondition(instance.getCondition()); 
    fluent.withConfig(instance.getConfig()); 
    fluent.withConfigMap(instance.getConfigMap()); 
    fluent.withConfigMapList(instance.getConfigMapList()); 
    fluent.withContainerStatus(instance.getContainerStatus()); 
    fluent.withCreateOptions(instance.getCreateOptions()); 
    fluent.withDeleteOptions(instance.getDeleteOptions()); 
    fluent.withEndpointPort(instance.getEndpointPort()); 
    fluent.withEndpoints(instance.getEndpoints()); 
    fluent.withEndpointsList(instance.getEndpointsList()); 
    fluent.withEnvVar(instance.getEnvVar()); 
    fluent.withEvent(instance.getEvent()); 
    fluent.withEventList(instance.getEventList()); 
    fluent.withEventSeries(instance.getEventSeries()); 
    fluent.withEventSource(instance.getEventSource()); 
    fluent.withGetOptions(instance.getGetOptions()); 
    fluent.withGroupVersionKind(instance.getGroupVersionKind()); 
    fluent.withGroupVersionResource(instance.getGroupVersionResource()); 
    fluent.withInfo(instance.getInfo()); 
    fluent.withLimitRangeList(instance.getLimitRangeList()); 
    fluent.withListOptions(instance.getListOptions()); 
    fluent.withMicroTime(instance.getMicroTime()); 
    fluent.withNamespace(instance.getNamespace()); 
    fluent.withNamespaceList(instance.getNamespaceList()); 
    fluent.withNode(instance.getNode()); 
    fluent.withNodeList(instance.getNodeList()); 
    fluent.withObjectMeta(instance.getObjectMeta()); 
    fluent.withPatch(instance.getPatch()); 
    fluent.withPatchOptions(instance.getPatchOptions()); 
    fluent.withPersistentVolume(instance.getPersistentVolume()); 
    fluent.withPersistentVolumeClaim(instance.getPersistentVolumeClaim()); 
    fluent.withPersistentVolumeClaimList(instance.getPersistentVolumeClaimList()); 
    fluent.withPersistentVolumeList(instance.getPersistentVolumeList()); 
    fluent.withPodExecOptions(instance.getPodExecOptions()); 
    fluent.withPodList(instance.getPodList()); 
    fluent.withPodTemplateList(instance.getPodTemplateList()); 
    fluent.withQuantity(instance.getQuantity()); 
    fluent.withReplicationControllerList(instance.getReplicationControllerList()); 
    fluent.withResourceQuota(instance.getResourceQuota()); 
    fluent.withResourceQuotaList(instance.getResourceQuotaList()); 
    fluent.withRootPaths(instance.getRootPaths()); 
    fluent.withSecret(instance.getSecret()); 
    fluent.withSecretList(instance.getSecretList()); 
    fluent.withServiceAccount(instance.getServiceAccount()); 
    fluent.withServiceAccountList(instance.getServiceAccountList()); 
    fluent.withServiceList(instance.getServiceList()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withTime(instance.getTime()); 
    fluent.withToleration(instance.getToleration()); 
    fluent.withTopologySelectorTerm(instance.getTopologySelectorTerm()); 
    fluent.withTypeMeta(instance.getTypeMeta()); 
    fluent.withUpdateOptions(instance.getUpdateOptions()); 
    fluent.withWatchEvent(instance.getWatchEvent()); 
    this.validationEnabled = validationEnabled; 
  }
  public KubeSchemaBuilder(io.fabric8.kubernetes.api.model.KubeSchema instance) {
    this(instance,false);
  }
  public KubeSchemaBuilder(io.fabric8.kubernetes.api.model.KubeSchema instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withAPIGroup(instance.getAPIGroup()); 
    this.withAPIGroupList(instance.getAPIGroupList()); 
    this.withAPIService(instance.getAPIService()); 
    this.withAPIServiceList(instance.getAPIServiceList()); 
    this.withBaseKubernetesList(instance.getBaseKubernetesList()); 
    this.withBinding(instance.getBinding()); 
    this.withComponentStatus(instance.getComponentStatus()); 
    this.withComponentStatusList(instance.getComponentStatusList()); 
    this.withCondition(instance.getCondition()); 
    this.withConfig(instance.getConfig()); 
    this.withConfigMap(instance.getConfigMap()); 
    this.withConfigMapList(instance.getConfigMapList()); 
    this.withContainerStatus(instance.getContainerStatus()); 
    this.withCreateOptions(instance.getCreateOptions()); 
    this.withDeleteOptions(instance.getDeleteOptions()); 
    this.withEndpointPort(instance.getEndpointPort()); 
    this.withEndpoints(instance.getEndpoints()); 
    this.withEndpointsList(instance.getEndpointsList()); 
    this.withEnvVar(instance.getEnvVar()); 
    this.withEvent(instance.getEvent()); 
    this.withEventList(instance.getEventList()); 
    this.withEventSeries(instance.getEventSeries()); 
    this.withEventSource(instance.getEventSource()); 
    this.withGetOptions(instance.getGetOptions()); 
    this.withGroupVersionKind(instance.getGroupVersionKind()); 
    this.withGroupVersionResource(instance.getGroupVersionResource()); 
    this.withInfo(instance.getInfo()); 
    this.withLimitRangeList(instance.getLimitRangeList()); 
    this.withListOptions(instance.getListOptions()); 
    this.withMicroTime(instance.getMicroTime()); 
    this.withNamespace(instance.getNamespace()); 
    this.withNamespaceList(instance.getNamespaceList()); 
    this.withNode(instance.getNode()); 
    this.withNodeList(instance.getNodeList()); 
    this.withObjectMeta(instance.getObjectMeta()); 
    this.withPatch(instance.getPatch()); 
    this.withPatchOptions(instance.getPatchOptions()); 
    this.withPersistentVolume(instance.getPersistentVolume()); 
    this.withPersistentVolumeClaim(instance.getPersistentVolumeClaim()); 
    this.withPersistentVolumeClaimList(instance.getPersistentVolumeClaimList()); 
    this.withPersistentVolumeList(instance.getPersistentVolumeList()); 
    this.withPodExecOptions(instance.getPodExecOptions()); 
    this.withPodList(instance.getPodList()); 
    this.withPodTemplateList(instance.getPodTemplateList()); 
    this.withQuantity(instance.getQuantity()); 
    this.withReplicationControllerList(instance.getReplicationControllerList()); 
    this.withResourceQuota(instance.getResourceQuota()); 
    this.withResourceQuotaList(instance.getResourceQuotaList()); 
    this.withRootPaths(instance.getRootPaths()); 
    this.withSecret(instance.getSecret()); 
    this.withSecretList(instance.getSecretList()); 
    this.withServiceAccount(instance.getServiceAccount()); 
    this.withServiceAccountList(instance.getServiceAccountList()); 
    this.withServiceList(instance.getServiceList()); 
    this.withStatus(instance.getStatus()); 
    this.withTime(instance.getTime()); 
    this.withToleration(instance.getToleration()); 
    this.withTopologySelectorTerm(instance.getTopologySelectorTerm()); 
    this.withTypeMeta(instance.getTypeMeta()); 
    this.withUpdateOptions(instance.getUpdateOptions()); 
    this.withWatchEvent(instance.getWatchEvent()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.KubeSchemaFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.KubeSchema build() {
    KubeSchema buildable = new KubeSchema(fluent.getAPIGroup(),fluent.getAPIGroupList(),fluent.getAPIService(),fluent.getAPIServiceList(),fluent.getBaseKubernetesList(),fluent.getBinding(),fluent.getComponentStatus(),fluent.getComponentStatusList(),fluent.getCondition(),fluent.getConfig(),fluent.getConfigMap(),fluent.getConfigMapList(),fluent.getContainerStatus(),fluent.getCreateOptions(),fluent.getDeleteOptions(),fluent.getEndpointPort(),fluent.getEndpoints(),fluent.getEndpointsList(),fluent.getEnvVar(),fluent.getEvent(),fluent.getEventList(),fluent.getEventSeries(),fluent.getEventSource(),fluent.getGetOptions(),fluent.getGroupVersionKind(),fluent.getGroupVersionResource(),fluent.getInfo(),fluent.getLimitRangeList(),fluent.getListOptions(),fluent.getMicroTime(),fluent.getNamespace(),fluent.getNamespaceList(),fluent.getNode(),fluent.getNodeList(),fluent.getObjectMeta(),fluent.getPatch(),fluent.getPatchOptions(),fluent.getPersistentVolume(),fluent.getPersistentVolumeClaim(),fluent.getPersistentVolumeClaimList(),fluent.getPersistentVolumeList(),fluent.getPodExecOptions(),fluent.getPodList(),fluent.getPodTemplateList(),fluent.getQuantity(),fluent.getReplicationControllerList(),fluent.getResourceQuota(),fluent.getResourceQuotaList(),fluent.getRootPaths(),fluent.getSecret(),fluent.getSecretList(),fluent.getServiceAccount(),fluent.getServiceAccountList(),fluent.getServiceList(),fluent.getStatus(),fluent.getTime(),fluent.getToleration(),fluent.getTopologySelectorTerm(),fluent.getTypeMeta(),fluent.getUpdateOptions(),fluent.getWatchEvent());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    KubeSchemaBuilder that = (KubeSchemaBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}