package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class KubernetesListBuilder extends io.fabric8.kubernetes.api.model.KubernetesListFluentImpl<io.fabric8.kubernetes.api.model.KubernetesListBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.KubernetesList,io.fabric8.kubernetes.api.model.KubernetesListBuilder>{
  public KubernetesListBuilder() {
    this(false);
  }
  public KubernetesListBuilder(java.lang.Boolean validationEnabled) {
    this(new KubernetesList(), validationEnabled);
  }
  public KubernetesListBuilder(io.fabric8.kubernetes.api.model.KubernetesListFluent<?> fluent) {
    this(fluent, false);
  }
  public KubernetesListBuilder(io.fabric8.kubernetes.api.model.KubernetesListFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new KubernetesList(), validationEnabled);
  }
  public KubernetesListBuilder(io.fabric8.kubernetes.api.model.KubernetesListFluent<?> fluent,io.fabric8.kubernetes.api.model.KubernetesList instance) {
    this(fluent, instance, false);
  }
  public KubernetesListBuilder(io.fabric8.kubernetes.api.model.KubernetesListFluent<?> fluent,io.fabric8.kubernetes.api.model.KubernetesList instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withItems(instance.getItems()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  public KubernetesListBuilder(io.fabric8.kubernetes.api.model.KubernetesList instance) {
    this(instance,false);
  }
  public KubernetesListBuilder(io.fabric8.kubernetes.api.model.KubernetesList instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withItems(instance.getItems()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.KubernetesListFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.KubernetesList build() {
    KubernetesList buildable = new KubernetesList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    KubernetesListBuilder that = (KubernetesListBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}