package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class LifecycleBuilder extends io.fabric8.kubernetes.api.model.LifecycleFluentImpl<io.fabric8.kubernetes.api.model.LifecycleBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.Lifecycle,io.fabric8.kubernetes.api.model.LifecycleBuilder>{
  public LifecycleBuilder() {
    this(false);
  }
  public LifecycleBuilder(java.lang.Boolean validationEnabled) {
    this(new Lifecycle(), validationEnabled);
  }
  public LifecycleBuilder(io.fabric8.kubernetes.api.model.LifecycleFluent<?> fluent) {
    this(fluent, false);
  }
  public LifecycleBuilder(io.fabric8.kubernetes.api.model.LifecycleFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new Lifecycle(), validationEnabled);
  }
  public LifecycleBuilder(io.fabric8.kubernetes.api.model.LifecycleFluent<?> fluent,io.fabric8.kubernetes.api.model.Lifecycle instance) {
    this(fluent, instance, false);
  }
  public LifecycleBuilder(io.fabric8.kubernetes.api.model.LifecycleFluent<?> fluent,io.fabric8.kubernetes.api.model.Lifecycle instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withPostStart(instance.getPostStart()); 
    fluent.withPreStop(instance.getPreStop()); 
    this.validationEnabled = validationEnabled; 
  }
  public LifecycleBuilder(io.fabric8.kubernetes.api.model.Lifecycle instance) {
    this(instance,false);
  }
  public LifecycleBuilder(io.fabric8.kubernetes.api.model.Lifecycle instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withPostStart(instance.getPostStart()); 
    this.withPreStop(instance.getPreStop()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.LifecycleFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.Lifecycle build() {
    Lifecycle buildable = new Lifecycle(fluent.getPostStart(),fluent.getPreStop());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    LifecycleBuilder that = (LifecycleBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}