package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class NamespaceConditionBuilder extends io.fabric8.kubernetes.api.model.NamespaceConditionFluentImpl<io.fabric8.kubernetes.api.model.NamespaceConditionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.NamespaceCondition,io.fabric8.kubernetes.api.model.NamespaceConditionBuilder>{
  public NamespaceConditionBuilder() {
    this(false);
  }
  public NamespaceConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new NamespaceCondition(), validationEnabled);
  }
  public NamespaceConditionBuilder(io.fabric8.kubernetes.api.model.NamespaceConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public NamespaceConditionBuilder(io.fabric8.kubernetes.api.model.NamespaceConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new NamespaceCondition(), validationEnabled);
  }
  public NamespaceConditionBuilder(io.fabric8.kubernetes.api.model.NamespaceConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.NamespaceCondition instance) {
    this(fluent, instance, false);
  }
  public NamespaceConditionBuilder(io.fabric8.kubernetes.api.model.NamespaceConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.NamespaceCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLastTransitionTime(instance.getLastTransitionTime()); 
    fluent.withMessage(instance.getMessage()); 
    fluent.withReason(instance.getReason()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public NamespaceConditionBuilder(io.fabric8.kubernetes.api.model.NamespaceCondition instance) {
    this(instance,false);
  }
  public NamespaceConditionBuilder(io.fabric8.kubernetes.api.model.NamespaceCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLastTransitionTime(instance.getLastTransitionTime()); 
    this.withMessage(instance.getMessage()); 
    this.withReason(instance.getReason()); 
    this.withStatus(instance.getStatus()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.NamespaceConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.NamespaceCondition build() {
    NamespaceCondition buildable = new NamespaceCondition(fluent.getLastTransitionTime(),fluent.getMessage(),fluent.getReason(),fluent.getStatus(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    NamespaceConditionBuilder that = (NamespaceConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}