package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class NodeListBuilder extends io.fabric8.kubernetes.api.model.NodeListFluentImpl<io.fabric8.kubernetes.api.model.NodeListBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.NodeList,io.fabric8.kubernetes.api.model.NodeListBuilder>{
  public NodeListBuilder() {
    this(false);
  }
  public NodeListBuilder(java.lang.Boolean validationEnabled) {
    this(new NodeList(), validationEnabled);
  }
  public NodeListBuilder(io.fabric8.kubernetes.api.model.NodeListFluent<?> fluent) {
    this(fluent, false);
  }
  public NodeListBuilder(io.fabric8.kubernetes.api.model.NodeListFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new NodeList(), validationEnabled);
  }
  public NodeListBuilder(io.fabric8.kubernetes.api.model.NodeListFluent<?> fluent,io.fabric8.kubernetes.api.model.NodeList instance) {
    this(fluent, instance, false);
  }
  public NodeListBuilder(io.fabric8.kubernetes.api.model.NodeListFluent<?> fluent,io.fabric8.kubernetes.api.model.NodeList instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withItems(instance.getItems()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  public NodeListBuilder(io.fabric8.kubernetes.api.model.NodeList instance) {
    this(instance,false);
  }
  public NodeListBuilder(io.fabric8.kubernetes.api.model.NodeList instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withItems(instance.getItems()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.NodeListFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.NodeList build() {
    NodeList buildable = new NodeList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    NodeListBuilder that = (NodeListBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}