package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonInclude;
import java.util.ArrayList;
import java.lang.String;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;
import io.fabric8.kubernetes.api.builder.Nested;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.Integer;

 /**
  * Generated
  */
public interface NodeStatusFluent<A extends io.fabric8.kubernetes.api.model.NodeStatusFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public A addToAddresses(java.lang.Integer index,io.fabric8.kubernetes.api.model.NodeAddress item);
  public A setToAddresses(java.lang.Integer index,io.fabric8.kubernetes.api.model.NodeAddress item);
  public A addToAddresses(io.fabric8.kubernetes.api.model.NodeAddress... items);
  public A addAllToAddresses(java.util.Collection<io.fabric8.kubernetes.api.model.NodeAddress> items);
  public A removeFromAddresses(io.fabric8.kubernetes.api.model.NodeAddress... items);
  public A removeAllFromAddresses(java.util.Collection<io.fabric8.kubernetes.api.model.NodeAddress> items);
  public A removeMatchingFromAddresses(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeAddressBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildAddresses instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.NodeAddress> getAddresses();
  public java.util.List<io.fabric8.kubernetes.api.model.NodeAddress> buildAddresses();
  public io.fabric8.kubernetes.api.model.NodeAddress buildAddress(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.NodeAddress buildFirstAddress();
  public io.fabric8.kubernetes.api.model.NodeAddress buildLastAddress();
  public io.fabric8.kubernetes.api.model.NodeAddress buildMatchingAddress(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeAddressBuilder> predicate);
  public java.lang.Boolean hasMatchingAddress(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeAddressBuilder> predicate);
  public A withAddresses(java.util.List<io.fabric8.kubernetes.api.model.NodeAddress> addresses);
  public A withAddresses(io.fabric8.kubernetes.api.model.NodeAddress... addresses);
  public java.lang.Boolean hasAddresses();
  public A addNewAddress(java.lang.String address,java.lang.String type);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> addNewAddress();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> addNewAddressLike(io.fabric8.kubernetes.api.model.NodeAddress item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> setNewAddressLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.NodeAddress item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> editAddress(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> editFirstAddress();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> editLastAddress();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<A> editMatchingAddress(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeAddressBuilder> predicate);
  public A addToAllocatable(java.lang.String key,io.fabric8.kubernetes.api.model.Quantity value);
  public A addToAllocatable(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> map);
  public A removeFromAllocatable(java.lang.String key);
  public A removeFromAllocatable(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> map);
  public java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> getAllocatable();
  public <K,V>A withAllocatable(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> allocatable);
  public java.lang.Boolean hasAllocatable();
  public A addToCapacity(java.lang.String key,io.fabric8.kubernetes.api.model.Quantity value);
  public A addToCapacity(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> map);
  public A removeFromCapacity(java.lang.String key);
  public A removeFromCapacity(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> map);
  public java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> getCapacity();
  public <K,V>A withCapacity(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> capacity);
  public java.lang.Boolean hasCapacity();
  public A addToConditions(java.lang.Integer index,io.fabric8.kubernetes.api.model.NodeCondition item);
  public A setToConditions(java.lang.Integer index,io.fabric8.kubernetes.api.model.NodeCondition item);
  public A addToConditions(io.fabric8.kubernetes.api.model.NodeCondition... items);
  public A addAllToConditions(java.util.Collection<io.fabric8.kubernetes.api.model.NodeCondition> items);
  public A removeFromConditions(io.fabric8.kubernetes.api.model.NodeCondition... items);
  public A removeAllFromConditions(java.util.Collection<io.fabric8.kubernetes.api.model.NodeCondition> items);
  public A removeMatchingFromConditions(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeConditionBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildConditions instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.NodeCondition> getConditions();
  public java.util.List<io.fabric8.kubernetes.api.model.NodeCondition> buildConditions();
  public io.fabric8.kubernetes.api.model.NodeCondition buildCondition(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.NodeCondition buildFirstCondition();
  public io.fabric8.kubernetes.api.model.NodeCondition buildLastCondition();
  public io.fabric8.kubernetes.api.model.NodeCondition buildMatchingCondition(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeConditionBuilder> predicate);
  public java.lang.Boolean hasMatchingCondition(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeConditionBuilder> predicate);
  public A withConditions(java.util.List<io.fabric8.kubernetes.api.model.NodeCondition> conditions);
  public A withConditions(io.fabric8.kubernetes.api.model.NodeCondition... conditions);
  public java.lang.Boolean hasConditions();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> addNewCondition();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> addNewConditionLike(io.fabric8.kubernetes.api.model.NodeCondition item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> setNewConditionLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.NodeCondition item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> editCondition(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> editFirstCondition();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> editLastCondition();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<A> editMatchingCondition(java.util.function.Predicate<io.fabric8.kubernetes.api.model.NodeConditionBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildConfig instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.NodeConfigStatus getConfig();
  public io.fabric8.kubernetes.api.model.NodeConfigStatus buildConfig();
  public A withConfig(io.fabric8.kubernetes.api.model.NodeConfigStatus config);
  public java.lang.Boolean hasConfig();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConfigNested<A> withNewConfig();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConfigNested<A> withNewConfigLike(io.fabric8.kubernetes.api.model.NodeConfigStatus item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConfigNested<A> editConfig();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConfigNested<A> editOrNewConfig();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ConfigNested<A> editOrNewConfigLike(io.fabric8.kubernetes.api.model.NodeConfigStatus item);
  
  /**
   * This method has been deprecated, please use method buildDaemonEndpoints instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.NodeDaemonEndpoints getDaemonEndpoints();
  public io.fabric8.kubernetes.api.model.NodeDaemonEndpoints buildDaemonEndpoints();
  public A withDaemonEndpoints(io.fabric8.kubernetes.api.model.NodeDaemonEndpoints daemonEndpoints);
  public java.lang.Boolean hasDaemonEndpoints();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.DaemonEndpointsNested<A> withNewDaemonEndpoints();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.DaemonEndpointsNested<A> withNewDaemonEndpointsLike(io.fabric8.kubernetes.api.model.NodeDaemonEndpoints item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.DaemonEndpointsNested<A> editDaemonEndpoints();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.DaemonEndpointsNested<A> editOrNewDaemonEndpoints();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.DaemonEndpointsNested<A> editOrNewDaemonEndpointsLike(io.fabric8.kubernetes.api.model.NodeDaemonEndpoints item);
  public A addToImages(java.lang.Integer index,io.fabric8.kubernetes.api.model.ContainerImage item);
  public A setToImages(java.lang.Integer index,io.fabric8.kubernetes.api.model.ContainerImage item);
  public A addToImages(io.fabric8.kubernetes.api.model.ContainerImage... items);
  public A addAllToImages(java.util.Collection<io.fabric8.kubernetes.api.model.ContainerImage> items);
  public A removeFromImages(io.fabric8.kubernetes.api.model.ContainerImage... items);
  public A removeAllFromImages(java.util.Collection<io.fabric8.kubernetes.api.model.ContainerImage> items);
  public A removeMatchingFromImages(java.util.function.Predicate<io.fabric8.kubernetes.api.model.ContainerImageBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildImages instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.ContainerImage> getImages();
  public java.util.List<io.fabric8.kubernetes.api.model.ContainerImage> buildImages();
  public io.fabric8.kubernetes.api.model.ContainerImage buildImage(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.ContainerImage buildFirstImage();
  public io.fabric8.kubernetes.api.model.ContainerImage buildLastImage();
  public io.fabric8.kubernetes.api.model.ContainerImage buildMatchingImage(java.util.function.Predicate<io.fabric8.kubernetes.api.model.ContainerImageBuilder> predicate);
  public java.lang.Boolean hasMatchingImage(java.util.function.Predicate<io.fabric8.kubernetes.api.model.ContainerImageBuilder> predicate);
  public A withImages(java.util.List<io.fabric8.kubernetes.api.model.ContainerImage> images);
  public A withImages(io.fabric8.kubernetes.api.model.ContainerImage... images);
  public java.lang.Boolean hasImages();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> addNewImage();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> addNewImageLike(io.fabric8.kubernetes.api.model.ContainerImage item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> setNewImageLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.ContainerImage item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> editImage(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> editFirstImage();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> editLastImage();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<A> editMatchingImage(java.util.function.Predicate<io.fabric8.kubernetes.api.model.ContainerImageBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildNodeInfo instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.NodeSystemInfo getNodeInfo();
  public io.fabric8.kubernetes.api.model.NodeSystemInfo buildNodeInfo();
  public A withNodeInfo(io.fabric8.kubernetes.api.model.NodeSystemInfo nodeInfo);
  public java.lang.Boolean hasNodeInfo();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.NodeInfoNested<A> withNewNodeInfo();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.NodeInfoNested<A> withNewNodeInfoLike(io.fabric8.kubernetes.api.model.NodeSystemInfo item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.NodeInfoNested<A> editNodeInfo();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.NodeInfoNested<A> editOrNewNodeInfo();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.NodeInfoNested<A> editOrNewNodeInfoLike(io.fabric8.kubernetes.api.model.NodeSystemInfo item);
  public java.lang.String getPhase();
  public A withPhase(java.lang.String phase);
  public java.lang.Boolean hasPhase();
  
  /**
   * Method is deprecated. use withPhase instead.
   */
  @java.lang.Deprecated
  public A withNewPhase(java.lang.String arg0);
  public A addToVolumesAttached(java.lang.Integer index,io.fabric8.kubernetes.api.model.AttachedVolume item);
  public A setToVolumesAttached(java.lang.Integer index,io.fabric8.kubernetes.api.model.AttachedVolume item);
  public A addToVolumesAttached(io.fabric8.kubernetes.api.model.AttachedVolume... items);
  public A addAllToVolumesAttached(java.util.Collection<io.fabric8.kubernetes.api.model.AttachedVolume> items);
  public A removeFromVolumesAttached(io.fabric8.kubernetes.api.model.AttachedVolume... items);
  public A removeAllFromVolumesAttached(java.util.Collection<io.fabric8.kubernetes.api.model.AttachedVolume> items);
  public A removeMatchingFromVolumesAttached(java.util.function.Predicate<io.fabric8.kubernetes.api.model.AttachedVolumeBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildVolumesAttached instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.AttachedVolume> getVolumesAttached();
  public java.util.List<io.fabric8.kubernetes.api.model.AttachedVolume> buildVolumesAttached();
  public io.fabric8.kubernetes.api.model.AttachedVolume buildVolumesAttached(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.AttachedVolume buildFirstVolumesAttached();
  public io.fabric8.kubernetes.api.model.AttachedVolume buildLastVolumesAttached();
  public io.fabric8.kubernetes.api.model.AttachedVolume buildMatchingVolumesAttached(java.util.function.Predicate<io.fabric8.kubernetes.api.model.AttachedVolumeBuilder> predicate);
  public java.lang.Boolean hasMatchingVolumesAttached(java.util.function.Predicate<io.fabric8.kubernetes.api.model.AttachedVolumeBuilder> predicate);
  public A withVolumesAttached(java.util.List<io.fabric8.kubernetes.api.model.AttachedVolume> volumesAttached);
  public A withVolumesAttached(io.fabric8.kubernetes.api.model.AttachedVolume... volumesAttached);
  public java.lang.Boolean hasVolumesAttached();
  public A addNewVolumesAttached(java.lang.String devicePath,java.lang.String name);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> addNewVolumesAttached();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> addNewVolumesAttachedLike(io.fabric8.kubernetes.api.model.AttachedVolume item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> setNewVolumesAttachedLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.AttachedVolume item);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> editVolumesAttached(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> editFirstVolumesAttached();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> editLastVolumesAttached();
  public io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<A> editMatchingVolumesAttached(java.util.function.Predicate<io.fabric8.kubernetes.api.model.AttachedVolumeBuilder> predicate);
  public A addToVolumesInUse(java.lang.Integer index,java.lang.String item);
  public A setToVolumesInUse(java.lang.Integer index,java.lang.String item);
  public A addToVolumesInUse(java.lang.String... items);
  public A addAllToVolumesInUse(java.util.Collection<java.lang.String> items);
  public A removeFromVolumesInUse(java.lang.String... items);
  public A removeAllFromVolumesInUse(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getVolumesInUse();
  public java.lang.String getVolumesInUse(java.lang.Integer index);
  public java.lang.String getFirstVolumesInUse();
  public java.lang.String getLastVolumesInUse();
  public java.lang.String getMatchingVolumesInUse(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingVolumesInUse(java.util.function.Predicate<java.lang.String> predicate);
  public A withVolumesInUse(java.util.List<java.lang.String> volumesInUse);
  public A withVolumesInUse(java.lang.String... volumesInUse);
  public java.lang.Boolean hasVolumesInUse();
  public A addNewVolumesInUse(java.lang.String arg0);
  public interface AddressesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.NodeAddressFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.AddressesNested<N>>{
    public N and();
    public N endAddress();
    
  }
  public interface ConditionsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.NodeConditionFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.ConditionsNested<N>>{
    public N and();
    public N endCondition();
    
  }
  public interface ConfigNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.NodeConfigStatusFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.ConfigNested<N>>{
    public N and();
    public N endConfig();
    
  }
  public interface DaemonEndpointsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.NodeDaemonEndpointsFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.DaemonEndpointsNested<N>>{
    public N and();
    public N endDaemonEndpoints();
    
  }
  public interface ImagesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ContainerImageFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.ImagesNested<N>>{
    public N and();
    public N endImage();
    
  }
  public interface NodeInfoNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.NodeSystemInfoFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.NodeInfoNested<N>>{
    public N and();
    public N endNodeInfo();
    
  }
  public interface VolumesAttachedNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.AttachedVolumeFluent<io.fabric8.kubernetes.api.model.NodeStatusFluent.VolumesAttachedNested<N>>{
    public N and();
    public N endVolumesAttached();
    
  }
  
}