package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ObjectMetaBuilder extends io.fabric8.kubernetes.api.model.ObjectMetaFluentImpl<io.fabric8.kubernetes.api.model.ObjectMetaBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.ObjectMeta,io.fabric8.kubernetes.api.model.ObjectMetaBuilder>{
  public ObjectMetaBuilder() {
    this(false);
  }
  public ObjectMetaBuilder(java.lang.Boolean validationEnabled) {
    this(new ObjectMeta(), validationEnabled);
  }
  public ObjectMetaBuilder(io.fabric8.kubernetes.api.model.ObjectMetaFluent<?> fluent) {
    this(fluent, false);
  }
  public ObjectMetaBuilder(io.fabric8.kubernetes.api.model.ObjectMetaFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ObjectMeta(), validationEnabled);
  }
  public ObjectMetaBuilder(io.fabric8.kubernetes.api.model.ObjectMetaFluent<?> fluent,io.fabric8.kubernetes.api.model.ObjectMeta instance) {
    this(fluent, instance, false);
  }
  public ObjectMetaBuilder(io.fabric8.kubernetes.api.model.ObjectMetaFluent<?> fluent,io.fabric8.kubernetes.api.model.ObjectMeta instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withAnnotations(instance.getAnnotations()); 
    fluent.withClusterName(instance.getClusterName()); 
    fluent.withCreationTimestamp(instance.getCreationTimestamp()); 
    fluent.withDeletionGracePeriodSeconds(instance.getDeletionGracePeriodSeconds()); 
    fluent.withDeletionTimestamp(instance.getDeletionTimestamp()); 
    fluent.withFinalizers(instance.getFinalizers()); 
    fluent.withGenerateName(instance.getGenerateName()); 
    fluent.withGeneration(instance.getGeneration()); 
    fluent.withLabels(instance.getLabels()); 
    fluent.withManagedFields(instance.getManagedFields()); 
    fluent.withName(instance.getName()); 
    fluent.withNamespace(instance.getNamespace()); 
    fluent.withOwnerReferences(instance.getOwnerReferences()); 
    fluent.withResourceVersion(instance.getResourceVersion()); 
    fluent.withSelfLink(instance.getSelfLink()); 
    fluent.withUid(instance.getUid()); 
    this.validationEnabled = validationEnabled; 
  }
  public ObjectMetaBuilder(io.fabric8.kubernetes.api.model.ObjectMeta instance) {
    this(instance,false);
  }
  public ObjectMetaBuilder(io.fabric8.kubernetes.api.model.ObjectMeta instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withAnnotations(instance.getAnnotations()); 
    this.withClusterName(instance.getClusterName()); 
    this.withCreationTimestamp(instance.getCreationTimestamp()); 
    this.withDeletionGracePeriodSeconds(instance.getDeletionGracePeriodSeconds()); 
    this.withDeletionTimestamp(instance.getDeletionTimestamp()); 
    this.withFinalizers(instance.getFinalizers()); 
    this.withGenerateName(instance.getGenerateName()); 
    this.withGeneration(instance.getGeneration()); 
    this.withLabels(instance.getLabels()); 
    this.withManagedFields(instance.getManagedFields()); 
    this.withName(instance.getName()); 
    this.withNamespace(instance.getNamespace()); 
    this.withOwnerReferences(instance.getOwnerReferences()); 
    this.withResourceVersion(instance.getResourceVersion()); 
    this.withSelfLink(instance.getSelfLink()); 
    this.withUid(instance.getUid()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.ObjectMetaFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.ObjectMeta build() {
    ObjectMeta buildable = new ObjectMeta(fluent.getAnnotations(),fluent.getClusterName(),fluent.getCreationTimestamp(),fluent.getDeletionGracePeriodSeconds(),fluent.getDeletionTimestamp(),fluent.getFinalizers(),fluent.getGenerateName(),fluent.getGeneration(),fluent.getLabels(),fluent.getManagedFields(),fluent.getName(),fluent.getNamespace(),fluent.getOwnerReferences(),fluent.getResourceVersion(),fluent.getSelfLink(),fluent.getUid());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ObjectMetaBuilder that = (ObjectMetaBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}