package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class PersistentVolumeClaimBuilder extends io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluentImpl<io.fabric8.kubernetes.api.model.PersistentVolumeClaimBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.PersistentVolumeClaim,io.fabric8.kubernetes.api.model.PersistentVolumeClaimBuilder>{
  public PersistentVolumeClaimBuilder() {
    this(false);
  }
  public PersistentVolumeClaimBuilder(java.lang.Boolean validationEnabled) {
    this(new PersistentVolumeClaim(), validationEnabled);
  }
  public PersistentVolumeClaimBuilder(io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluent<?> fluent) {
    this(fluent, false);
  }
  public PersistentVolumeClaimBuilder(io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new PersistentVolumeClaim(), validationEnabled);
  }
  public PersistentVolumeClaimBuilder(io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluent<?> fluent,io.fabric8.kubernetes.api.model.PersistentVolumeClaim instance) {
    this(fluent, instance, false);
  }
  public PersistentVolumeClaimBuilder(io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluent<?> fluent,io.fabric8.kubernetes.api.model.PersistentVolumeClaim instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    fluent.withSpec(instance.getSpec()); 
    fluent.withStatus(instance.getStatus()); 
    this.validationEnabled = validationEnabled; 
  }
  public PersistentVolumeClaimBuilder(io.fabric8.kubernetes.api.model.PersistentVolumeClaim instance) {
    this(instance,false);
  }
  public PersistentVolumeClaimBuilder(io.fabric8.kubernetes.api.model.PersistentVolumeClaim instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.withSpec(instance.getSpec()); 
    this.withStatus(instance.getStatus()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.PersistentVolumeClaimFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaim build() {
    PersistentVolumeClaim buildable = new PersistentVolumeClaim(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    PersistentVolumeClaimBuilder that = (PersistentVolumeClaimBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}