package io.fabric8.kubernetes.api.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Deprecated;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.Integer;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface PersistentVolumeClaimSpecFluent<A extends io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public A addToAccessModes(java.lang.Integer index,java.lang.String item);
  public A setToAccessModes(java.lang.Integer index,java.lang.String item);
  public A addToAccessModes(java.lang.String... items);
  public A addAllToAccessModes(java.util.Collection<java.lang.String> items);
  public A removeFromAccessModes(java.lang.String... items);
  public A removeAllFromAccessModes(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getAccessModes();
  public java.lang.String getAccessMode(java.lang.Integer index);
  public java.lang.String getFirstAccessMode();
  public java.lang.String getLastAccessMode();
  public java.lang.String getMatchingAccessMode(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingAccessMode(java.util.function.Predicate<java.lang.String> predicate);
  public A withAccessModes(java.util.List<java.lang.String> accessModes);
  public A withAccessModes(java.lang.String... accessModes);
  public java.lang.Boolean hasAccessModes();
  public A addNewAccessMode(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildDataSource instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.TypedLocalObjectReference getDataSource();
  public io.fabric8.kubernetes.api.model.TypedLocalObjectReference buildDataSource();
  public A withDataSource(io.fabric8.kubernetes.api.model.TypedLocalObjectReference dataSource);
  public java.lang.Boolean hasDataSource();
  public A withNewDataSource(java.lang.String apiGroup,java.lang.String kind,java.lang.String name);
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.DataSourceNested<A> withNewDataSource();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.DataSourceNested<A> withNewDataSourceLike(io.fabric8.kubernetes.api.model.TypedLocalObjectReference item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.DataSourceNested<A> editDataSource();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.DataSourceNested<A> editOrNewDataSource();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.DataSourceNested<A> editOrNewDataSourceLike(io.fabric8.kubernetes.api.model.TypedLocalObjectReference item);
  
  /**
   * This method has been deprecated, please use method buildResources instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ResourceRequirements getResources();
  public io.fabric8.kubernetes.api.model.ResourceRequirements buildResources();
  public A withResources(io.fabric8.kubernetes.api.model.ResourceRequirements resources);
  public java.lang.Boolean hasResources();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.ResourcesNested<A> withNewResources();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.ResourcesNested<A> withNewResourcesLike(io.fabric8.kubernetes.api.model.ResourceRequirements item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.ResourcesNested<A> editResources();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.ResourcesNested<A> editOrNewResources();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.ResourcesNested<A> editOrNewResourcesLike(io.fabric8.kubernetes.api.model.ResourceRequirements item);
  
  /**
   * This method has been deprecated, please use method buildSelector instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.LabelSelector getSelector();
  public io.fabric8.kubernetes.api.model.LabelSelector buildSelector();
  public A withSelector(io.fabric8.kubernetes.api.model.LabelSelector selector);
  public java.lang.Boolean hasSelector();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.SelectorNested<A> withNewSelector();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.SelectorNested<A> withNewSelectorLike(io.fabric8.kubernetes.api.model.LabelSelector item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.SelectorNested<A> editSelector();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.SelectorNested<A> editOrNewSelector();
  public io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.SelectorNested<A> editOrNewSelectorLike(io.fabric8.kubernetes.api.model.LabelSelector item);
  public java.lang.String getStorageClassName();
  public A withStorageClassName(java.lang.String storageClassName);
  public java.lang.Boolean hasStorageClassName();
  
  /**
   * Method is deprecated. use withStorageClassName instead.
   */
  @java.lang.Deprecated
  public A withNewStorageClassName(java.lang.String arg0);
  public java.lang.String getVolumeMode();
  public A withVolumeMode(java.lang.String volumeMode);
  public java.lang.Boolean hasVolumeMode();
  
  /**
   * Method is deprecated. use withVolumeMode instead.
   */
  @java.lang.Deprecated
  public A withNewVolumeMode(java.lang.String arg0);
  public java.lang.String getVolumeName();
  public A withVolumeName(java.lang.String volumeName);
  public java.lang.Boolean hasVolumeName();
  
  /**
   * Method is deprecated. use withVolumeName instead.
   */
  @java.lang.Deprecated
  public A withNewVolumeName(java.lang.String arg0);
  public interface DataSourceNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.TypedLocalObjectReferenceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.DataSourceNested<N>>{
    public N and();
    public N endDataSource();
    
  }
  public interface ResourcesNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ResourceRequirementsFluent<io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.ResourcesNested<N>>{
    public N and();
    public N endResources();
    
  }
  public interface SelectorNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.LabelSelectorFluent<io.fabric8.kubernetes.api.model.PersistentVolumeClaimSpecFluent.SelectorNested<N>>{
    public N and();
    public N endSelector();
    
  }
  
}