package io.fabric8.kubernetes.api.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonInclude;
import java.util.ArrayList;
import java.lang.String;
import java.lang.Boolean;
import java.lang.Object;
import java.util.Map;
import java.lang.Deprecated;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.util.List;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.util.Collection;
import io.fabric8.kubernetes.api.builder.Nested;
import java.lang.Integer;

 /**
  * Generated
  */
public interface PersistentVolumeSpecFluent<A extends io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public A addToAccessModes(java.lang.Integer index,java.lang.String item);
  public A setToAccessModes(java.lang.Integer index,java.lang.String item);
  public A addToAccessModes(java.lang.String... items);
  public A addAllToAccessModes(java.util.Collection<java.lang.String> items);
  public A removeFromAccessModes(java.lang.String... items);
  public A removeAllFromAccessModes(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getAccessModes();
  public java.lang.String getAccessMode(java.lang.Integer index);
  public java.lang.String getFirstAccessMode();
  public java.lang.String getLastAccessMode();
  public java.lang.String getMatchingAccessMode(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingAccessMode(java.util.function.Predicate<java.lang.String> predicate);
  public A withAccessModes(java.util.List<java.lang.String> accessModes);
  public A withAccessModes(java.lang.String... accessModes);
  public java.lang.Boolean hasAccessModes();
  public A addNewAccessMode(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildAwsElasticBlockStore instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.AWSElasticBlockStoreVolumeSource getAwsElasticBlockStore();
  public io.fabric8.kubernetes.api.model.AWSElasticBlockStoreVolumeSource buildAwsElasticBlockStore();
  public A withAwsElasticBlockStore(io.fabric8.kubernetes.api.model.AWSElasticBlockStoreVolumeSource awsElasticBlockStore);
  public java.lang.Boolean hasAwsElasticBlockStore();
  public A withNewAwsElasticBlockStore(java.lang.String fsType,java.lang.Integer partition,java.lang.Boolean readOnly,java.lang.String volumeID);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AwsElasticBlockStoreNested<A> withNewAwsElasticBlockStore();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AwsElasticBlockStoreNested<A> withNewAwsElasticBlockStoreLike(io.fabric8.kubernetes.api.model.AWSElasticBlockStoreVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AwsElasticBlockStoreNested<A> editAwsElasticBlockStore();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AwsElasticBlockStoreNested<A> editOrNewAwsElasticBlockStore();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AwsElasticBlockStoreNested<A> editOrNewAwsElasticBlockStoreLike(io.fabric8.kubernetes.api.model.AWSElasticBlockStoreVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildAzureDisk instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.AzureDiskVolumeSource getAzureDisk();
  public io.fabric8.kubernetes.api.model.AzureDiskVolumeSource buildAzureDisk();
  public A withAzureDisk(io.fabric8.kubernetes.api.model.AzureDiskVolumeSource azureDisk);
  public java.lang.Boolean hasAzureDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureDiskNested<A> withNewAzureDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureDiskNested<A> withNewAzureDiskLike(io.fabric8.kubernetes.api.model.AzureDiskVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureDiskNested<A> editAzureDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureDiskNested<A> editOrNewAzureDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureDiskNested<A> editOrNewAzureDiskLike(io.fabric8.kubernetes.api.model.AzureDiskVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildAzureFile instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.AzureFilePersistentVolumeSource getAzureFile();
  public io.fabric8.kubernetes.api.model.AzureFilePersistentVolumeSource buildAzureFile();
  public A withAzureFile(io.fabric8.kubernetes.api.model.AzureFilePersistentVolumeSource azureFile);
  public java.lang.Boolean hasAzureFile();
  public A withNewAzureFile(java.lang.Boolean readOnly,java.lang.String secretName,java.lang.String secretNamespace,java.lang.String shareName);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureFileNested<A> withNewAzureFile();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureFileNested<A> withNewAzureFileLike(io.fabric8.kubernetes.api.model.AzureFilePersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureFileNested<A> editAzureFile();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureFileNested<A> editOrNewAzureFile();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureFileNested<A> editOrNewAzureFileLike(io.fabric8.kubernetes.api.model.AzureFilePersistentVolumeSource item);
  public A addToCapacity(java.lang.String key,io.fabric8.kubernetes.api.model.Quantity value);
  public A addToCapacity(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> map);
  public A removeFromCapacity(java.lang.String key);
  public A removeFromCapacity(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> map);
  public java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> getCapacity();
  public <K,V>A withCapacity(java.util.Map<java.lang.String,io.fabric8.kubernetes.api.model.Quantity> capacity);
  public java.lang.Boolean hasCapacity();
  
  /**
   * This method has been deprecated, please use method buildCephfs instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.CephFSPersistentVolumeSource getCephfs();
  public io.fabric8.kubernetes.api.model.CephFSPersistentVolumeSource buildCephfs();
  public A withCephfs(io.fabric8.kubernetes.api.model.CephFSPersistentVolumeSource cephfs);
  public java.lang.Boolean hasCephfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CephfsNested<A> withNewCephfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CephfsNested<A> withNewCephfsLike(io.fabric8.kubernetes.api.model.CephFSPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CephfsNested<A> editCephfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CephfsNested<A> editOrNewCephfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CephfsNested<A> editOrNewCephfsLike(io.fabric8.kubernetes.api.model.CephFSPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildCinder instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.CinderPersistentVolumeSource getCinder();
  public io.fabric8.kubernetes.api.model.CinderPersistentVolumeSource buildCinder();
  public A withCinder(io.fabric8.kubernetes.api.model.CinderPersistentVolumeSource cinder);
  public java.lang.Boolean hasCinder();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CinderNested<A> withNewCinder();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CinderNested<A> withNewCinderLike(io.fabric8.kubernetes.api.model.CinderPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CinderNested<A> editCinder();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CinderNested<A> editOrNewCinder();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CinderNested<A> editOrNewCinderLike(io.fabric8.kubernetes.api.model.CinderPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildClaimRef instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ObjectReference getClaimRef();
  public io.fabric8.kubernetes.api.model.ObjectReference buildClaimRef();
  public A withClaimRef(io.fabric8.kubernetes.api.model.ObjectReference claimRef);
  public java.lang.Boolean hasClaimRef();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ClaimRefNested<A> withNewClaimRef();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ClaimRefNested<A> withNewClaimRefLike(io.fabric8.kubernetes.api.model.ObjectReference item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ClaimRefNested<A> editClaimRef();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ClaimRefNested<A> editOrNewClaimRef();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ClaimRefNested<A> editOrNewClaimRefLike(io.fabric8.kubernetes.api.model.ObjectReference item);
  
  /**
   * This method has been deprecated, please use method buildCsi instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.CSIPersistentVolumeSource getCsi();
  public io.fabric8.kubernetes.api.model.CSIPersistentVolumeSource buildCsi();
  public A withCsi(io.fabric8.kubernetes.api.model.CSIPersistentVolumeSource csi);
  public java.lang.Boolean hasCsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CsiNested<A> withNewCsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CsiNested<A> withNewCsiLike(io.fabric8.kubernetes.api.model.CSIPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CsiNested<A> editCsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CsiNested<A> editOrNewCsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CsiNested<A> editOrNewCsiLike(io.fabric8.kubernetes.api.model.CSIPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildFc instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.FCVolumeSource getFc();
  public io.fabric8.kubernetes.api.model.FCVolumeSource buildFc();
  public A withFc(io.fabric8.kubernetes.api.model.FCVolumeSource fc);
  public java.lang.Boolean hasFc();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FcNested<A> withNewFc();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FcNested<A> withNewFcLike(io.fabric8.kubernetes.api.model.FCVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FcNested<A> editFc();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FcNested<A> editOrNewFc();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FcNested<A> editOrNewFcLike(io.fabric8.kubernetes.api.model.FCVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildFlexVolume instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.FlexPersistentVolumeSource getFlexVolume();
  public io.fabric8.kubernetes.api.model.FlexPersistentVolumeSource buildFlexVolume();
  public A withFlexVolume(io.fabric8.kubernetes.api.model.FlexPersistentVolumeSource flexVolume);
  public java.lang.Boolean hasFlexVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlexVolumeNested<A> withNewFlexVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlexVolumeNested<A> withNewFlexVolumeLike(io.fabric8.kubernetes.api.model.FlexPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlexVolumeNested<A> editFlexVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlexVolumeNested<A> editOrNewFlexVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlexVolumeNested<A> editOrNewFlexVolumeLike(io.fabric8.kubernetes.api.model.FlexPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildFlocker instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.FlockerVolumeSource getFlocker();
  public io.fabric8.kubernetes.api.model.FlockerVolumeSource buildFlocker();
  public A withFlocker(io.fabric8.kubernetes.api.model.FlockerVolumeSource flocker);
  public java.lang.Boolean hasFlocker();
  public A withNewFlocker(java.lang.String datasetName,java.lang.String datasetUUID);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlockerNested<A> withNewFlocker();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlockerNested<A> withNewFlockerLike(io.fabric8.kubernetes.api.model.FlockerVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlockerNested<A> editFlocker();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlockerNested<A> editOrNewFlocker();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlockerNested<A> editOrNewFlockerLike(io.fabric8.kubernetes.api.model.FlockerVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildGcePersistentDisk instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.GCEPersistentDiskVolumeSource getGcePersistentDisk();
  public io.fabric8.kubernetes.api.model.GCEPersistentDiskVolumeSource buildGcePersistentDisk();
  public A withGcePersistentDisk(io.fabric8.kubernetes.api.model.GCEPersistentDiskVolumeSource gcePersistentDisk);
  public java.lang.Boolean hasGcePersistentDisk();
  public A withNewGcePersistentDisk(java.lang.String fsType,java.lang.Integer partition,java.lang.String pdName,java.lang.Boolean readOnly);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GcePersistentDiskNested<A> withNewGcePersistentDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GcePersistentDiskNested<A> withNewGcePersistentDiskLike(io.fabric8.kubernetes.api.model.GCEPersistentDiskVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GcePersistentDiskNested<A> editGcePersistentDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GcePersistentDiskNested<A> editOrNewGcePersistentDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GcePersistentDiskNested<A> editOrNewGcePersistentDiskLike(io.fabric8.kubernetes.api.model.GCEPersistentDiskVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildGlusterfs instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.GlusterfsPersistentVolumeSource getGlusterfs();
  public io.fabric8.kubernetes.api.model.GlusterfsPersistentVolumeSource buildGlusterfs();
  public A withGlusterfs(io.fabric8.kubernetes.api.model.GlusterfsPersistentVolumeSource glusterfs);
  public java.lang.Boolean hasGlusterfs();
  public A withNewGlusterfs(java.lang.String endpoints,java.lang.String endpointsNamespace,java.lang.String path,java.lang.Boolean readOnly);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GlusterfsNested<A> withNewGlusterfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GlusterfsNested<A> withNewGlusterfsLike(io.fabric8.kubernetes.api.model.GlusterfsPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GlusterfsNested<A> editGlusterfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GlusterfsNested<A> editOrNewGlusterfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GlusterfsNested<A> editOrNewGlusterfsLike(io.fabric8.kubernetes.api.model.GlusterfsPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildHostPath instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.HostPathVolumeSource getHostPath();
  public io.fabric8.kubernetes.api.model.HostPathVolumeSource buildHostPath();
  public A withHostPath(io.fabric8.kubernetes.api.model.HostPathVolumeSource hostPath);
  public java.lang.Boolean hasHostPath();
  public A withNewHostPath(java.lang.String path,java.lang.String type);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.HostPathNested<A> withNewHostPath();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.HostPathNested<A> withNewHostPathLike(io.fabric8.kubernetes.api.model.HostPathVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.HostPathNested<A> editHostPath();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.HostPathNested<A> editOrNewHostPath();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.HostPathNested<A> editOrNewHostPathLike(io.fabric8.kubernetes.api.model.HostPathVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildIscsi instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ISCSIPersistentVolumeSource getIscsi();
  public io.fabric8.kubernetes.api.model.ISCSIPersistentVolumeSource buildIscsi();
  public A withIscsi(io.fabric8.kubernetes.api.model.ISCSIPersistentVolumeSource iscsi);
  public java.lang.Boolean hasIscsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.IscsiNested<A> withNewIscsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.IscsiNested<A> withNewIscsiLike(io.fabric8.kubernetes.api.model.ISCSIPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.IscsiNested<A> editIscsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.IscsiNested<A> editOrNewIscsi();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.IscsiNested<A> editOrNewIscsiLike(io.fabric8.kubernetes.api.model.ISCSIPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildLocal instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.LocalVolumeSource getLocal();
  public io.fabric8.kubernetes.api.model.LocalVolumeSource buildLocal();
  public A withLocal(io.fabric8.kubernetes.api.model.LocalVolumeSource local);
  public java.lang.Boolean hasLocal();
  public A withNewLocal(java.lang.String fsType,java.lang.String path);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.LocalNested<A> withNewLocal();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.LocalNested<A> withNewLocalLike(io.fabric8.kubernetes.api.model.LocalVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.LocalNested<A> editLocal();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.LocalNested<A> editOrNewLocal();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.LocalNested<A> editOrNewLocalLike(io.fabric8.kubernetes.api.model.LocalVolumeSource item);
  public A addToMountOptions(java.lang.Integer index,java.lang.String item);
  public A setToMountOptions(java.lang.Integer index,java.lang.String item);
  public A addToMountOptions(java.lang.String... items);
  public A addAllToMountOptions(java.util.Collection<java.lang.String> items);
  public A removeFromMountOptions(java.lang.String... items);
  public A removeAllFromMountOptions(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getMountOptions();
  public java.lang.String getMountOption(java.lang.Integer index);
  public java.lang.String getFirstMountOption();
  public java.lang.String getLastMountOption();
  public java.lang.String getMatchingMountOption(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingMountOption(java.util.function.Predicate<java.lang.String> predicate);
  public A withMountOptions(java.util.List<java.lang.String> mountOptions);
  public A withMountOptions(java.lang.String... mountOptions);
  public java.lang.Boolean hasMountOptions();
  public A addNewMountOption(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildNfs instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.NFSVolumeSource getNfs();
  public io.fabric8.kubernetes.api.model.NFSVolumeSource buildNfs();
  public A withNfs(io.fabric8.kubernetes.api.model.NFSVolumeSource nfs);
  public java.lang.Boolean hasNfs();
  public A withNewNfs(java.lang.String path,java.lang.Boolean readOnly,java.lang.String server);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NfsNested<A> withNewNfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NfsNested<A> withNewNfsLike(io.fabric8.kubernetes.api.model.NFSVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NfsNested<A> editNfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NfsNested<A> editOrNewNfs();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NfsNested<A> editOrNewNfsLike(io.fabric8.kubernetes.api.model.NFSVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildNodeAffinity instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.VolumeNodeAffinity getNodeAffinity();
  public io.fabric8.kubernetes.api.model.VolumeNodeAffinity buildNodeAffinity();
  public A withNodeAffinity(io.fabric8.kubernetes.api.model.VolumeNodeAffinity nodeAffinity);
  public java.lang.Boolean hasNodeAffinity();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NodeAffinityNested<A> withNewNodeAffinity();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NodeAffinityNested<A> withNewNodeAffinityLike(io.fabric8.kubernetes.api.model.VolumeNodeAffinity item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NodeAffinityNested<A> editNodeAffinity();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NodeAffinityNested<A> editOrNewNodeAffinity();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NodeAffinityNested<A> editOrNewNodeAffinityLike(io.fabric8.kubernetes.api.model.VolumeNodeAffinity item);
  public java.lang.String getPersistentVolumeReclaimPolicy();
  public A withPersistentVolumeReclaimPolicy(java.lang.String persistentVolumeReclaimPolicy);
  public java.lang.Boolean hasPersistentVolumeReclaimPolicy();
  
  /**
   * Method is deprecated. use withPersistentVolumeReclaimPolicy instead.
   */
  @java.lang.Deprecated
  public A withNewPersistentVolumeReclaimPolicy(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildPhotonPersistentDisk instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.PhotonPersistentDiskVolumeSource getPhotonPersistentDisk();
  public io.fabric8.kubernetes.api.model.PhotonPersistentDiskVolumeSource buildPhotonPersistentDisk();
  public A withPhotonPersistentDisk(io.fabric8.kubernetes.api.model.PhotonPersistentDiskVolumeSource photonPersistentDisk);
  public java.lang.Boolean hasPhotonPersistentDisk();
  public A withNewPhotonPersistentDisk(java.lang.String fsType,java.lang.String pdID);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PhotonPersistentDiskNested<A> withNewPhotonPersistentDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PhotonPersistentDiskNested<A> withNewPhotonPersistentDiskLike(io.fabric8.kubernetes.api.model.PhotonPersistentDiskVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PhotonPersistentDiskNested<A> editPhotonPersistentDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PhotonPersistentDiskNested<A> editOrNewPhotonPersistentDisk();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PhotonPersistentDiskNested<A> editOrNewPhotonPersistentDiskLike(io.fabric8.kubernetes.api.model.PhotonPersistentDiskVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildPortworxVolume instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.PortworxVolumeSource getPortworxVolume();
  public io.fabric8.kubernetes.api.model.PortworxVolumeSource buildPortworxVolume();
  public A withPortworxVolume(io.fabric8.kubernetes.api.model.PortworxVolumeSource portworxVolume);
  public java.lang.Boolean hasPortworxVolume();
  public A withNewPortworxVolume(java.lang.String fsType,java.lang.Boolean readOnly,java.lang.String volumeID);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PortworxVolumeNested<A> withNewPortworxVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PortworxVolumeNested<A> withNewPortworxVolumeLike(io.fabric8.kubernetes.api.model.PortworxVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PortworxVolumeNested<A> editPortworxVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PortworxVolumeNested<A> editOrNewPortworxVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PortworxVolumeNested<A> editOrNewPortworxVolumeLike(io.fabric8.kubernetes.api.model.PortworxVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildQuobyte instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.QuobyteVolumeSource getQuobyte();
  public io.fabric8.kubernetes.api.model.QuobyteVolumeSource buildQuobyte();
  public A withQuobyte(io.fabric8.kubernetes.api.model.QuobyteVolumeSource quobyte);
  public java.lang.Boolean hasQuobyte();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.QuobyteNested<A> withNewQuobyte();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.QuobyteNested<A> withNewQuobyteLike(io.fabric8.kubernetes.api.model.QuobyteVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.QuobyteNested<A> editQuobyte();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.QuobyteNested<A> editOrNewQuobyte();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.QuobyteNested<A> editOrNewQuobyteLike(io.fabric8.kubernetes.api.model.QuobyteVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildRbd instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.RBDPersistentVolumeSource getRbd();
  public io.fabric8.kubernetes.api.model.RBDPersistentVolumeSource buildRbd();
  public A withRbd(io.fabric8.kubernetes.api.model.RBDPersistentVolumeSource rbd);
  public java.lang.Boolean hasRbd();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.RbdNested<A> withNewRbd();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.RbdNested<A> withNewRbdLike(io.fabric8.kubernetes.api.model.RBDPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.RbdNested<A> editRbd();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.RbdNested<A> editOrNewRbd();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.RbdNested<A> editOrNewRbdLike(io.fabric8.kubernetes.api.model.RBDPersistentVolumeSource item);
  
  /**
   * This method has been deprecated, please use method buildScaleIO instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ScaleIOPersistentVolumeSource getScaleIO();
  public io.fabric8.kubernetes.api.model.ScaleIOPersistentVolumeSource buildScaleIO();
  public A withScaleIO(io.fabric8.kubernetes.api.model.ScaleIOPersistentVolumeSource scaleIO);
  public java.lang.Boolean hasScaleIO();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ScaleIONested<A> withNewScaleIO();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ScaleIONested<A> withNewScaleIOLike(io.fabric8.kubernetes.api.model.ScaleIOPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ScaleIONested<A> editScaleIO();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ScaleIONested<A> editOrNewScaleIO();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ScaleIONested<A> editOrNewScaleIOLike(io.fabric8.kubernetes.api.model.ScaleIOPersistentVolumeSource item);
  public java.lang.String getStorageClassName();
  public A withStorageClassName(java.lang.String storageClassName);
  public java.lang.Boolean hasStorageClassName();
  
  /**
   * Method is deprecated. use withStorageClassName instead.
   */
  @java.lang.Deprecated
  public A withNewStorageClassName(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildStorageos instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.StorageOSPersistentVolumeSource getStorageos();
  public io.fabric8.kubernetes.api.model.StorageOSPersistentVolumeSource buildStorageos();
  public A withStorageos(io.fabric8.kubernetes.api.model.StorageOSPersistentVolumeSource storageos);
  public java.lang.Boolean hasStorageos();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.StorageosNested<A> withNewStorageos();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.StorageosNested<A> withNewStorageosLike(io.fabric8.kubernetes.api.model.StorageOSPersistentVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.StorageosNested<A> editStorageos();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.StorageosNested<A> editOrNewStorageos();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.StorageosNested<A> editOrNewStorageosLike(io.fabric8.kubernetes.api.model.StorageOSPersistentVolumeSource item);
  public java.lang.String getVolumeMode();
  public A withVolumeMode(java.lang.String volumeMode);
  public java.lang.Boolean hasVolumeMode();
  
  /**
   * Method is deprecated. use withVolumeMode instead.
   */
  @java.lang.Deprecated
  public A withNewVolumeMode(java.lang.String arg0);
  
  /**
   * This method has been deprecated, please use method buildVsphereVolume instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.VsphereVirtualDiskVolumeSource getVsphereVolume();
  public io.fabric8.kubernetes.api.model.VsphereVirtualDiskVolumeSource buildVsphereVolume();
  public A withVsphereVolume(io.fabric8.kubernetes.api.model.VsphereVirtualDiskVolumeSource vsphereVolume);
  public java.lang.Boolean hasVsphereVolume();
  public A withNewVsphereVolume(java.lang.String fsType,java.lang.String storagePolicyID,java.lang.String storagePolicyName,java.lang.String volumePath);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.VsphereVolumeNested<A> withNewVsphereVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.VsphereVolumeNested<A> withNewVsphereVolumeLike(io.fabric8.kubernetes.api.model.VsphereVirtualDiskVolumeSource item);
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.VsphereVolumeNested<A> editVsphereVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.VsphereVolumeNested<A> editOrNewVsphereVolume();
  public io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.VsphereVolumeNested<A> editOrNewVsphereVolumeLike(io.fabric8.kubernetes.api.model.VsphereVirtualDiskVolumeSource item);
  public interface AwsElasticBlockStoreNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.AWSElasticBlockStoreVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AwsElasticBlockStoreNested<N>>{
    public N and();
    public N endAwsElasticBlockStore();
    
  }
  public interface AzureDiskNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.AzureDiskVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureDiskNested<N>>{
    public N and();
    public N endAzureDisk();
    
  }
  public interface AzureFileNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.AzureFilePersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.AzureFileNested<N>>{
    public N and();
    public N endAzureFile();
    
  }
  public interface CephfsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.CephFSPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CephfsNested<N>>{
    public N and();
    public N endCephfs();
    
  }
  public interface CinderNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.CinderPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CinderNested<N>>{
    public N and();
    public N endCinder();
    
  }
  public interface ClaimRefNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ObjectReferenceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ClaimRefNested<N>>{
    public N and();
    public N endClaimRef();
    
  }
  public interface CsiNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.CSIPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.CsiNested<N>>{
    public N and();
    public N endCsi();
    
  }
  public interface FcNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.FCVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FcNested<N>>{
    public N and();
    public N endFc();
    
  }
  public interface FlexVolumeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.FlexPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlexVolumeNested<N>>{
    public N and();
    public N endFlexVolume();
    
  }
  public interface FlockerNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.FlockerVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.FlockerNested<N>>{
    public N and();
    public N endFlocker();
    
  }
  public interface GcePersistentDiskNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.GCEPersistentDiskVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GcePersistentDiskNested<N>>{
    public N and();
    public N endGcePersistentDisk();
    
  }
  public interface GlusterfsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.GlusterfsPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.GlusterfsNested<N>>{
    public N and();
    public N endGlusterfs();
    
  }
  public interface HostPathNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.HostPathVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.HostPathNested<N>>{
    public N and();
    public N endHostPath();
    
  }
  public interface IscsiNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ISCSIPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.IscsiNested<N>>{
    public N and();
    public N endIscsi();
    
  }
  public interface LocalNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.LocalVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.LocalNested<N>>{
    public N and();
    public N endLocal();
    
  }
  public interface NfsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.NFSVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NfsNested<N>>{
    public N and();
    public N endNfs();
    
  }
  public interface NodeAffinityNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.VolumeNodeAffinityFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.NodeAffinityNested<N>>{
    public N and();
    public N endNodeAffinity();
    
  }
  public interface PhotonPersistentDiskNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.PhotonPersistentDiskVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PhotonPersistentDiskNested<N>>{
    public N and();
    public N endPhotonPersistentDisk();
    
  }
  public interface PortworxVolumeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.PortworxVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.PortworxVolumeNested<N>>{
    public N and();
    public N endPortworxVolume();
    
  }
  public interface QuobyteNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.QuobyteVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.QuobyteNested<N>>{
    public N and();
    public N endQuobyte();
    
  }
  public interface RbdNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.RBDPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.RbdNested<N>>{
    public N and();
    public N endRbd();
    
  }
  public interface ScaleIONested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.ScaleIOPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.ScaleIONested<N>>{
    public N and();
    public N endScaleIO();
    
  }
  public interface StorageosNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.StorageOSPersistentVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.StorageosNested<N>>{
    public N and();
    public N endStorageos();
    
  }
  public interface VsphereVolumeNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.VsphereVirtualDiskVolumeSourceFluent<io.fabric8.kubernetes.api.model.PersistentVolumeSpecFluent.VsphereVolumeNested<N>>{
    public N and();
    public N endVsphereVolume();
    
  }
  
}