package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class PodDNSConfigBuilder extends io.fabric8.kubernetes.api.model.PodDNSConfigFluentImpl<io.fabric8.kubernetes.api.model.PodDNSConfigBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.PodDNSConfig,io.fabric8.kubernetes.api.model.PodDNSConfigBuilder>{
  public PodDNSConfigBuilder() {
    this(false);
  }
  public PodDNSConfigBuilder(java.lang.Boolean validationEnabled) {
    this(new PodDNSConfig(), validationEnabled);
  }
  public PodDNSConfigBuilder(io.fabric8.kubernetes.api.model.PodDNSConfigFluent<?> fluent) {
    this(fluent, false);
  }
  public PodDNSConfigBuilder(io.fabric8.kubernetes.api.model.PodDNSConfigFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new PodDNSConfig(), validationEnabled);
  }
  public PodDNSConfigBuilder(io.fabric8.kubernetes.api.model.PodDNSConfigFluent<?> fluent,io.fabric8.kubernetes.api.model.PodDNSConfig instance) {
    this(fluent, instance, false);
  }
  public PodDNSConfigBuilder(io.fabric8.kubernetes.api.model.PodDNSConfigFluent<?> fluent,io.fabric8.kubernetes.api.model.PodDNSConfig instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withNameservers(instance.getNameservers()); 
    fluent.withOptions(instance.getOptions()); 
    fluent.withSearches(instance.getSearches()); 
    this.validationEnabled = validationEnabled; 
  }
  public PodDNSConfigBuilder(io.fabric8.kubernetes.api.model.PodDNSConfig instance) {
    this(instance,false);
  }
  public PodDNSConfigBuilder(io.fabric8.kubernetes.api.model.PodDNSConfig instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withNameservers(instance.getNameservers()); 
    this.withOptions(instance.getOptions()); 
    this.withSearches(instance.getSearches()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.PodDNSConfigFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.PodDNSConfig build() {
    PodDNSConfig buildable = new PodDNSConfig(fluent.getNameservers(),fluent.getOptions(),fluent.getSearches());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    PodDNSConfigBuilder that = (PodDNSConfigBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}