package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Fluent;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;
import java.util.Map;

 /**
  * Generated
  */
public interface PodDNSConfigFluent<A extends io.fabric8.kubernetes.api.model.PodDNSConfigFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public A addToNameservers(java.lang.Integer index,java.lang.String item);
  public A setToNameservers(java.lang.Integer index,java.lang.String item);
  public A addToNameservers(java.lang.String... items);
  public A addAllToNameservers(java.util.Collection<java.lang.String> items);
  public A removeFromNameservers(java.lang.String... items);
  public A removeAllFromNameservers(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getNameservers();
  public java.lang.String getNameserver(java.lang.Integer index);
  public java.lang.String getFirstNameserver();
  public java.lang.String getLastNameserver();
  public java.lang.String getMatchingNameserver(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingNameserver(java.util.function.Predicate<java.lang.String> predicate);
  public A withNameservers(java.util.List<java.lang.String> nameservers);
  public A withNameservers(java.lang.String... nameservers);
  public java.lang.Boolean hasNameservers();
  public A addNewNameserver(java.lang.String arg0);
  public A addToOptions(java.lang.Integer index,io.fabric8.kubernetes.api.model.PodDNSConfigOption item);
  public A setToOptions(java.lang.Integer index,io.fabric8.kubernetes.api.model.PodDNSConfigOption item);
  public A addToOptions(io.fabric8.kubernetes.api.model.PodDNSConfigOption... items);
  public A addAllToOptions(java.util.Collection<io.fabric8.kubernetes.api.model.PodDNSConfigOption> items);
  public A removeFromOptions(io.fabric8.kubernetes.api.model.PodDNSConfigOption... items);
  public A removeAllFromOptions(java.util.Collection<io.fabric8.kubernetes.api.model.PodDNSConfigOption> items);
  public A removeMatchingFromOptions(java.util.function.Predicate<io.fabric8.kubernetes.api.model.PodDNSConfigOptionBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildOptions instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.PodDNSConfigOption> getOptions();
  public java.util.List<io.fabric8.kubernetes.api.model.PodDNSConfigOption> buildOptions();
  public io.fabric8.kubernetes.api.model.PodDNSConfigOption buildOption(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.PodDNSConfigOption buildFirstOption();
  public io.fabric8.kubernetes.api.model.PodDNSConfigOption buildLastOption();
  public io.fabric8.kubernetes.api.model.PodDNSConfigOption buildMatchingOption(java.util.function.Predicate<io.fabric8.kubernetes.api.model.PodDNSConfigOptionBuilder> predicate);
  public java.lang.Boolean hasMatchingOption(java.util.function.Predicate<io.fabric8.kubernetes.api.model.PodDNSConfigOptionBuilder> predicate);
  public A withOptions(java.util.List<io.fabric8.kubernetes.api.model.PodDNSConfigOption> options);
  public A withOptions(io.fabric8.kubernetes.api.model.PodDNSConfigOption... options);
  public java.lang.Boolean hasOptions();
  public A addNewOption(java.lang.String name,java.lang.String value);
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> addNewOption();
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> addNewOptionLike(io.fabric8.kubernetes.api.model.PodDNSConfigOption item);
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> setNewOptionLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.PodDNSConfigOption item);
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> editOption(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> editFirstOption();
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> editLastOption();
  public io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<A> editMatchingOption(java.util.function.Predicate<io.fabric8.kubernetes.api.model.PodDNSConfigOptionBuilder> predicate);
  public A addToSearches(java.lang.Integer index,java.lang.String item);
  public A setToSearches(java.lang.Integer index,java.lang.String item);
  public A addToSearches(java.lang.String... items);
  public A addAllToSearches(java.util.Collection<java.lang.String> items);
  public A removeFromSearches(java.lang.String... items);
  public A removeAllFromSearches(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getSearches();
  public java.lang.String getSearch(java.lang.Integer index);
  public java.lang.String getFirstSearch();
  public java.lang.String getLastSearch();
  public java.lang.String getMatchingSearch(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingSearch(java.util.function.Predicate<java.lang.String> predicate);
  public A withSearches(java.util.List<java.lang.String> searches);
  public A withSearches(java.lang.String... searches);
  public java.lang.Boolean hasSearches();
  public A addNewSearch(java.lang.String arg0);
  public interface OptionsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.PodDNSConfigOptionFluent<io.fabric8.kubernetes.api.model.PodDNSConfigFluent.OptionsNested<N>>{
    public N and();
    public N endOption();
    
  }
  
}