package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.List;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.lang.Integer;
import java.lang.Long;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

 /**
  * Generated
  */
public interface PodSecurityContextFluent<A extends io.fabric8.kubernetes.api.model.PodSecurityContextFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.Long getFsGroup();
  public A withFsGroup(java.lang.Long fsGroup);
  public java.lang.Boolean hasFsGroup();
  public java.lang.String getFsGroupChangePolicy();
  public A withFsGroupChangePolicy(java.lang.String fsGroupChangePolicy);
  public java.lang.Boolean hasFsGroupChangePolicy();
  
  /**
   * Method is deprecated. use withFsGroupChangePolicy instead.
   */
  @java.lang.Deprecated
  public A withNewFsGroupChangePolicy(java.lang.String arg0);
  public java.lang.Long getRunAsGroup();
  public A withRunAsGroup(java.lang.Long runAsGroup);
  public java.lang.Boolean hasRunAsGroup();
  public java.lang.Boolean getRunAsNonRoot();
  public A withRunAsNonRoot(java.lang.Boolean runAsNonRoot);
  public java.lang.Boolean hasRunAsNonRoot();
  public java.lang.Long getRunAsUser();
  public A withRunAsUser(java.lang.Long runAsUser);
  public java.lang.Boolean hasRunAsUser();
  
  /**
   * This method has been deprecated, please use method buildSeLinuxOptions instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.SELinuxOptions getSeLinuxOptions();
  public io.fabric8.kubernetes.api.model.SELinuxOptions buildSeLinuxOptions();
  public A withSeLinuxOptions(io.fabric8.kubernetes.api.model.SELinuxOptions seLinuxOptions);
  public java.lang.Boolean hasSeLinuxOptions();
  public A withNewSeLinuxOptions(java.lang.String level,java.lang.String role,java.lang.String type,java.lang.String user);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeLinuxOptionsNested<A> withNewSeLinuxOptions();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeLinuxOptionsNested<A> withNewSeLinuxOptionsLike(io.fabric8.kubernetes.api.model.SELinuxOptions item);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeLinuxOptionsNested<A> editSeLinuxOptions();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeLinuxOptionsNested<A> editOrNewSeLinuxOptions();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeLinuxOptionsNested<A> editOrNewSeLinuxOptionsLike(io.fabric8.kubernetes.api.model.SELinuxOptions item);
  
  /**
   * This method has been deprecated, please use method buildSeccompProfile instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.SeccompProfile getSeccompProfile();
  public io.fabric8.kubernetes.api.model.SeccompProfile buildSeccompProfile();
  public A withSeccompProfile(io.fabric8.kubernetes.api.model.SeccompProfile seccompProfile);
  public java.lang.Boolean hasSeccompProfile();
  public A withNewSeccompProfile(java.lang.String localhostProfile,java.lang.String type);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeccompProfileNested<A> withNewSeccompProfile();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeccompProfileNested<A> withNewSeccompProfileLike(io.fabric8.kubernetes.api.model.SeccompProfile item);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeccompProfileNested<A> editSeccompProfile();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeccompProfileNested<A> editOrNewSeccompProfile();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeccompProfileNested<A> editOrNewSeccompProfileLike(io.fabric8.kubernetes.api.model.SeccompProfile item);
  public A addToSupplementalGroups(java.lang.Integer index,java.lang.Long item);
  public A setToSupplementalGroups(java.lang.Integer index,java.lang.Long item);
  public A addToSupplementalGroups(java.lang.Long... items);
  public A addAllToSupplementalGroups(java.util.Collection<java.lang.Long> items);
  public A removeFromSupplementalGroups(java.lang.Long... items);
  public A removeAllFromSupplementalGroups(java.util.Collection<java.lang.Long> items);
  public java.util.List<java.lang.Long> getSupplementalGroups();
  public java.lang.Long getSupplementalGroup(java.lang.Integer index);
  public java.lang.Long getFirstSupplementalGroup();
  public java.lang.Long getLastSupplementalGroup();
  public java.lang.Long getMatchingSupplementalGroup(java.util.function.Predicate<java.lang.Long> predicate);
  public java.lang.Boolean hasMatchingSupplementalGroup(java.util.function.Predicate<java.lang.Long> predicate);
  public A withSupplementalGroups(java.util.List<java.lang.Long> supplementalGroups);
  public A withSupplementalGroups(java.lang.Long... supplementalGroups);
  public java.lang.Boolean hasSupplementalGroups();
  public A addToSysctls(java.lang.Integer index,io.fabric8.kubernetes.api.model.Sysctl item);
  public A setToSysctls(java.lang.Integer index,io.fabric8.kubernetes.api.model.Sysctl item);
  public A addToSysctls(io.fabric8.kubernetes.api.model.Sysctl... items);
  public A addAllToSysctls(java.util.Collection<io.fabric8.kubernetes.api.model.Sysctl> items);
  public A removeFromSysctls(io.fabric8.kubernetes.api.model.Sysctl... items);
  public A removeAllFromSysctls(java.util.Collection<io.fabric8.kubernetes.api.model.Sysctl> items);
  public A removeMatchingFromSysctls(java.util.function.Predicate<io.fabric8.kubernetes.api.model.SysctlBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildSysctls instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public java.util.List<io.fabric8.kubernetes.api.model.Sysctl> getSysctls();
  public java.util.List<io.fabric8.kubernetes.api.model.Sysctl> buildSysctls();
  public io.fabric8.kubernetes.api.model.Sysctl buildSysctl(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.Sysctl buildFirstSysctl();
  public io.fabric8.kubernetes.api.model.Sysctl buildLastSysctl();
  public io.fabric8.kubernetes.api.model.Sysctl buildMatchingSysctl(java.util.function.Predicate<io.fabric8.kubernetes.api.model.SysctlBuilder> predicate);
  public java.lang.Boolean hasMatchingSysctl(java.util.function.Predicate<io.fabric8.kubernetes.api.model.SysctlBuilder> predicate);
  public A withSysctls(java.util.List<io.fabric8.kubernetes.api.model.Sysctl> sysctls);
  public A withSysctls(io.fabric8.kubernetes.api.model.Sysctl... sysctls);
  public java.lang.Boolean hasSysctls();
  public A addNewSysctl(java.lang.String name,java.lang.String value);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> addNewSysctl();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> addNewSysctlLike(io.fabric8.kubernetes.api.model.Sysctl item);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> setNewSysctlLike(java.lang.Integer index,io.fabric8.kubernetes.api.model.Sysctl item);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> editSysctl(java.lang.Integer index);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> editFirstSysctl();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> editLastSysctl();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<A> editMatchingSysctl(java.util.function.Predicate<io.fabric8.kubernetes.api.model.SysctlBuilder> predicate);
  
  /**
   * This method has been deprecated, please use method buildWindowsOptions instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.WindowsSecurityContextOptions getWindowsOptions();
  public io.fabric8.kubernetes.api.model.WindowsSecurityContextOptions buildWindowsOptions();
  public A withWindowsOptions(io.fabric8.kubernetes.api.model.WindowsSecurityContextOptions windowsOptions);
  public java.lang.Boolean hasWindowsOptions();
  public A withNewWindowsOptions(java.lang.String gmsaCredentialSpec,java.lang.String gmsaCredentialSpecName,java.lang.String runAsUserName);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.WindowsOptionsNested<A> withNewWindowsOptions();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.WindowsOptionsNested<A> withNewWindowsOptionsLike(io.fabric8.kubernetes.api.model.WindowsSecurityContextOptions item);
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.WindowsOptionsNested<A> editWindowsOptions();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.WindowsOptionsNested<A> editOrNewWindowsOptions();
  public io.fabric8.kubernetes.api.model.PodSecurityContextFluent.WindowsOptionsNested<A> editOrNewWindowsOptionsLike(io.fabric8.kubernetes.api.model.WindowsSecurityContextOptions item);
  public interface SeLinuxOptionsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.SELinuxOptionsFluent<io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeLinuxOptionsNested<N>>{
    public N and();
    public N endSeLinuxOptions();
    
  }
  public interface SeccompProfileNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.SeccompProfileFluent<io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SeccompProfileNested<N>>{
    public N and();
    public N endSeccompProfile();
    
  }
  public interface SysctlsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.SysctlFluent<io.fabric8.kubernetes.api.model.PodSecurityContextFluent.SysctlsNested<N>>{
    public N and();
    public N endSysctl();
    
  }
  public interface WindowsOptionsNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.WindowsSecurityContextOptionsFluent<io.fabric8.kubernetes.api.model.PodSecurityContextFluent.WindowsOptionsNested<N>>{
    public N and();
    public N endWindowsOptions();
    
  }
  
}