package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ReplicationControllerConditionBuilder extends io.fabric8.kubernetes.api.model.ReplicationControllerConditionFluentImpl<io.fabric8.kubernetes.api.model.ReplicationControllerConditionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.ReplicationControllerCondition,io.fabric8.kubernetes.api.model.ReplicationControllerConditionBuilder>{
  public ReplicationControllerConditionBuilder() {
    this(false);
  }
  public ReplicationControllerConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new ReplicationControllerCondition(), validationEnabled);
  }
  public ReplicationControllerConditionBuilder(io.fabric8.kubernetes.api.model.ReplicationControllerConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public ReplicationControllerConditionBuilder(io.fabric8.kubernetes.api.model.ReplicationControllerConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ReplicationControllerCondition(), validationEnabled);
  }
  public ReplicationControllerConditionBuilder(io.fabric8.kubernetes.api.model.ReplicationControllerConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.ReplicationControllerCondition instance) {
    this(fluent, instance, false);
  }
  public ReplicationControllerConditionBuilder(io.fabric8.kubernetes.api.model.ReplicationControllerConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.ReplicationControllerCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLastTransitionTime(instance.getLastTransitionTime()); 
    fluent.withMessage(instance.getMessage()); 
    fluent.withReason(instance.getReason()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public ReplicationControllerConditionBuilder(io.fabric8.kubernetes.api.model.ReplicationControllerCondition instance) {
    this(instance,false);
  }
  public ReplicationControllerConditionBuilder(io.fabric8.kubernetes.api.model.ReplicationControllerCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLastTransitionTime(instance.getLastTransitionTime()); 
    this.withMessage(instance.getMessage()); 
    this.withReason(instance.getReason()); 
    this.withStatus(instance.getStatus()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.ReplicationControllerConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.ReplicationControllerCondition build() {
    ReplicationControllerCondition buildable = new ReplicationControllerCondition(fluent.getLastTransitionTime(),fluent.getMessage(),fluent.getReason(),fluent.getStatus(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ReplicationControllerConditionBuilder that = (ReplicationControllerConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}