package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ServiceListBuilder extends io.fabric8.kubernetes.api.model.ServiceListFluentImpl<io.fabric8.kubernetes.api.model.ServiceListBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.ServiceList,io.fabric8.kubernetes.api.model.ServiceListBuilder>{
  public ServiceListBuilder() {
    this(false);
  }
  public ServiceListBuilder(java.lang.Boolean validationEnabled) {
    this(new ServiceList(), validationEnabled);
  }
  public ServiceListBuilder(io.fabric8.kubernetes.api.model.ServiceListFluent<?> fluent) {
    this(fluent, false);
  }
  public ServiceListBuilder(io.fabric8.kubernetes.api.model.ServiceListFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ServiceList(), validationEnabled);
  }
  public ServiceListBuilder(io.fabric8.kubernetes.api.model.ServiceListFluent<?> fluent,io.fabric8.kubernetes.api.model.ServiceList instance) {
    this(fluent, instance, false);
  }
  public ServiceListBuilder(io.fabric8.kubernetes.api.model.ServiceListFluent<?> fluent,io.fabric8.kubernetes.api.model.ServiceList instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withApiVersion(instance.getApiVersion()); 
    fluent.withItems(instance.getItems()); 
    fluent.withKind(instance.getKind()); 
    fluent.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  public ServiceListBuilder(io.fabric8.kubernetes.api.model.ServiceList instance) {
    this(instance,false);
  }
  public ServiceListBuilder(io.fabric8.kubernetes.api.model.ServiceList instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withApiVersion(instance.getApiVersion()); 
    this.withItems(instance.getItems()); 
    this.withKind(instance.getKind()); 
    this.withMetadata(instance.getMetadata()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.ServiceListFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.ServiceList build() {
    ServiceList buildable = new ServiceList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ServiceListBuilder that = (ServiceListBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}