package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class StatusDetailsBuilder extends io.fabric8.kubernetes.api.model.StatusDetailsFluentImpl<io.fabric8.kubernetes.api.model.StatusDetailsBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.StatusDetails,io.fabric8.kubernetes.api.model.StatusDetailsBuilder>{
  public StatusDetailsBuilder() {
    this(false);
  }
  public StatusDetailsBuilder(java.lang.Boolean validationEnabled) {
    this(new StatusDetails(), validationEnabled);
  }
  public StatusDetailsBuilder(io.fabric8.kubernetes.api.model.StatusDetailsFluent<?> fluent) {
    this(fluent, false);
  }
  public StatusDetailsBuilder(io.fabric8.kubernetes.api.model.StatusDetailsFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new StatusDetails(), validationEnabled);
  }
  public StatusDetailsBuilder(io.fabric8.kubernetes.api.model.StatusDetailsFluent<?> fluent,io.fabric8.kubernetes.api.model.StatusDetails instance) {
    this(fluent, instance, false);
  }
  public StatusDetailsBuilder(io.fabric8.kubernetes.api.model.StatusDetailsFluent<?> fluent,io.fabric8.kubernetes.api.model.StatusDetails instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withCauses(instance.getCauses()); 
    fluent.withGroup(instance.getGroup()); 
    fluent.withKind(instance.getKind()); 
    fluent.withName(instance.getName()); 
    fluent.withRetryAfterSeconds(instance.getRetryAfterSeconds()); 
    fluent.withUid(instance.getUid()); 
    this.validationEnabled = validationEnabled; 
  }
  public StatusDetailsBuilder(io.fabric8.kubernetes.api.model.StatusDetails instance) {
    this(instance,false);
  }
  public StatusDetailsBuilder(io.fabric8.kubernetes.api.model.StatusDetails instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withCauses(instance.getCauses()); 
    this.withGroup(instance.getGroup()); 
    this.withKind(instance.getKind()); 
    this.withName(instance.getName()); 
    this.withRetryAfterSeconds(instance.getRetryAfterSeconds()); 
    this.withUid(instance.getUid()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.StatusDetailsFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.StatusDetails build() {
    StatusDetails buildable = new StatusDetails(fluent.getCauses(),fluent.getGroup(),fluent.getKind(),fluent.getName(),fluent.getRetryAfterSeconds(),fluent.getUid());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    StatusDetailsBuilder that = (StatusDetailsBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}