package io.fabric8.kubernetes.api.model;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class VolumeProjectionBuilder extends io.fabric8.kubernetes.api.model.VolumeProjectionFluentImpl<io.fabric8.kubernetes.api.model.VolumeProjectionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.VolumeProjection,io.fabric8.kubernetes.api.model.VolumeProjectionBuilder>{
  public VolumeProjectionBuilder() {
    this(false);
  }
  public VolumeProjectionBuilder(java.lang.Boolean validationEnabled) {
    this(new VolumeProjection(), validationEnabled);
  }
  public VolumeProjectionBuilder(io.fabric8.kubernetes.api.model.VolumeProjectionFluent<?> fluent) {
    this(fluent, false);
  }
  public VolumeProjectionBuilder(io.fabric8.kubernetes.api.model.VolumeProjectionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new VolumeProjection(), validationEnabled);
  }
  public VolumeProjectionBuilder(io.fabric8.kubernetes.api.model.VolumeProjectionFluent<?> fluent,io.fabric8.kubernetes.api.model.VolumeProjection instance) {
    this(fluent, instance, false);
  }
  public VolumeProjectionBuilder(io.fabric8.kubernetes.api.model.VolumeProjectionFluent<?> fluent,io.fabric8.kubernetes.api.model.VolumeProjection instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withConfigMap(instance.getConfigMap()); 
    fluent.withDownwardAPI(instance.getDownwardAPI()); 
    fluent.withSecret(instance.getSecret()); 
    fluent.withServiceAccountToken(instance.getServiceAccountToken()); 
    this.validationEnabled = validationEnabled; 
  }
  public VolumeProjectionBuilder(io.fabric8.kubernetes.api.model.VolumeProjection instance) {
    this(instance,false);
  }
  public VolumeProjectionBuilder(io.fabric8.kubernetes.api.model.VolumeProjection instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withConfigMap(instance.getConfigMap()); 
    this.withDownwardAPI(instance.getDownwardAPI()); 
    this.withSecret(instance.getSecret()); 
    this.withServiceAccountToken(instance.getServiceAccountToken()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.VolumeProjectionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.VolumeProjection build() {
    VolumeProjection buildable = new VolumeProjection(fluent.getConfigMap(),fluent.getDownwardAPI(),fluent.getSecret(),fluent.getServiceAccountToken());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    VolumeProjectionBuilder that = (VolumeProjectionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}